/* long ascii scroller ascii */

#include "asciiFont.h"
#include "asciiArt.h"

class Ascii
{
public:
  Ascii ()
  {
    yscroll=0;
    asciiCount=0;  // ascii file byte index
    nextLine=39;
    screenLine = 39;
    eight=0;

    init();
  }

  void init()
  {
    GD.uncompress(RAM_CHR, ascii_chr);
    GD.uncompress(RAM_PAL, ascii_pal);

    // put the first screen worth of art on screen
    //    for (int y=0; y < 39; y++)
    //      readLine(y);

    GD.fill(RAM_PIC, 0xDB, 0x0FFF);  // Zero all character RAM with white
  }

  void draw()
  {
    /* scroll up */
    if (nextLine<255+40+40) 
    {
      GD.wr16(SCROLL_Y, yscroll++); 
      GD.waitvblank();

      if (eight==8)
      {
        if (screenLine > 63) 
        {
          screenLine=0;
        }

        // put new line on screen
        readLine(screenLine++); 
        nextLine++;
        eight=0;
      }
      eight++;
    }
    else
    {
      fadeAll();
    }
  }

private:  
  int yscroll;
  int asciiCount;  // ascii file byte index
  int nextLine;
  int screenLine;
  int eight;

  // get a line from ascii at y pos.  from ascii y,  to screen y
  void readLine(int destY){
    char msg[52];
    memset(msg, 32, sizeof(msg)); // make a empty row with ascii chr 32=space
    char cc=0;
    int x = 0;

    while (cc!=10 &  asciiCount < sizeof(fullascii)-1  ){
      cc = pgm_read_byte_near(&fullascii[asciiCount++]);
      msg[x] = cc;

      if (cc==10 || cc==13) msg[x]=32;
      x++;
    }

    putascii( 0,  destY, msg);  // write row to screen
  }

  // put an array of chars on screen
  void putascii(int x, int y, const char *s)
  {
    GD.__wstart((y << 6) + x);
    while (*s)
      SPI.transfer((*s++));
    GD.__end();
  }

  // put a single char on screen
  void putascii(int x, int y, char s)
  {
    GD.__wstart((y << 6) + x);
    SPI.transfer(s);
    GD.__end();
  }

};





