#include <SPI.h>
#include <GD.h>

void fadeAll(){

  for (int t = 0; t < 8 * 72; t++) {
    byte frame = (t & 1);

    if (t < 32)
      bgfade(t);
    if (((8 * 72) - 32) < t) {
      bgfade(8 * 72 - t);
      for (uint16_t a = RAM_PAL; a < RAM_PAL + (256 * 4 * 2); a += 32)
        fade16(a);
      fade16(PALETTE16A);
    }
  }
}

void bgfade(byte t)
{
  for (byte i = 0; i < 64; i++) {
    byte l = ((t == 31) ? 8 : 0) + ((i * t) >> 4);
    GD.wr16(0x3e80 + 2 * i, RGB(l, l, l));
  }
}

static void fade(uint16_t addr)
{
  uint16_t col = GD.rd16(addr);
  if (col & (31 << 10)) col -= (1 << 10);
  if (col & (31 << 5))  col -= (1 << 5);
  if (col & 31)         col -= 1;
  GD.wr16(addr, col);
}

// Fade 16 palette entries starting at addr
static void fade16(uint16_t addr)
{
  uint16_t cols[16];
  GD.__start(addr);
  for (byte i = 0; i < 16; i++) {
    byte lo = SPI.transfer(0);
    byte hi = SPI.transfer(0);
    uint16_t col = (hi << 8) | lo;
    if (col & (31 << 10)) col -= (1 << 10);
    if (col & (31 << 5))  col -= (1 << 5);
    if (col & 31)         col -= 1;
    cols[i] = col;
  }
  GD.__end();

  GD.__wstart(addr);
  for (byte i = 0; i < 16; i++) {
    uint16_t col = cols[i];
    SPI.transfer(lowByte(col));
    SPI.transfer(highByte(col));
  }
  GD.__end();
}

#include "ascii.h"
#include <digitalWriteFast.h>

void setup()
{
  GD.begin();

}

void loop()
{
  // 35 seconds
  runAscii((256*8) + 3*(8*38) ); // ascii is 256 lines long x 8 pixel tiles
}

void runAscii(int framesToRun){
  Ascii* ascii;
  ascii = new Ascii();

  do{
    ascii->draw();
    //    screenshot();
  }
  while(--framesToRun);
  delete(ascii);  
}

