/*

 Name      :  3D Starfield
 Notes     :  sprite based stars comming at you
 
 */


#define NUM_STARS_3D 30

class StarField3D
{
public:
  StarField3D ()
  {
    maxX = SCREEN_WIDTH;
    maxY = SCREEN_HEIGHT;
    minZ = 0;
    maxZ = 1825;  //larger number is slower
    init();

    GD.copy(RAM_SPRPAL, sm_logo_sprpal, sizeof(sm_logo_sprpal));
    GD.uncompress(RAM_SPRIMG, sm_logo_sprimg);

  }

  void init()
  {
    for ( int i = 0 ; i < NUM_STARS_3D ; ++i )
    {
      newStar( i );
      z[i] = (int)(random() * (double)(maxZ - minZ)) + minZ   ;
    }
  }

  void move()
  {
    int amountToMove = 8;
    for(int i = 0; i < NUM_STARS_3D; i++)
    {
      // Rotate star
      z[i] = z[i] - amountToMove;
      if(z[i] < minZ)
        newStar(i);
    }
  }

  void draw()
  {
    move();

    GD.__wstartspr(flip ? 256 : 0);      

    int scrW = SCREEN_WIDTH / 2;
    int scrH = SCREEN_HEIGHT / 2;
    for(int i = 0; i < NUM_STARS_3D; i++)
    {
      int sx = (x[i] * 256) / z[i] + scrW;
      int sy = (y[i] * 256) / z[i] + scrH;
      if(sx < 0 || sx > SCREEN_WIDTH || sy < 0 || sy > SCREEN_HEIGHT)
      {
        newStar(i);
      }
      else
      {
        int darkness=  map(z[i], minZ, maxZ, 1, 10);// 10 is number of shaded stars
        draw_sm_star_shaded(sx-8, sy-8, darkness, 0);    
      }
    }

    draw_sm_logo((SCREEN_WIDTH/2)+8, (SCREEN_HEIGHT/2)+8, 0, 0);    

    GD.__end();
    GD.waitvblank(); 
    GD.wr(SPR_PAGE, flip);
    flip = !flip;
  }

private:
  // 3d effect
  int x[NUM_STARS_3D];
  int y[NUM_STARS_3D];
  int z[NUM_STARS_3D];

  int maxX;
  int maxY;
  int minZ;
  int maxZ;

  void newStar( int starNr )
  {
    x[starNr] = (int)(random(0,maxX) ) + 1;
    y[starNr] = (int)(random(0,maxY) ) + 1;
    z[starNr] = (int)(random(0,maxZ) ) + 1 ; //maxZ;

    int i = (int)(random(0,4.0) );
    if(i < 2)
      x[starNr] = -x[starNr];
    if(i == 0 || i == 2)
      y[starNr] = -y[starNr];
  }
};


