/*

 Name      :  Ascii Scroller
 Notes     :  ending credits scroller

uses full dos ascii set encoded into gd character memory.  scrolls up 1 row at a time.
 
 */
 
#include "asciiFont.h"
extern const uint32_t fullascii,fullasciiSize;


class Ascii
{
public:

  Ascii (int lines)
  {
    linesToScroll = lines;
    yscroll=0;
    asciiCount=0;  // ascii file byte index
    nextLine=39;
    screenLine = 39;
    eight=0;

    init();
  }

  void init()
  {
    GD.uncompress(RAM_CHR, ascii_chr);
    GD.uncompress(RAM_PAL, ascii_pal);

    // put the first screen worth of art on screen
    //    for (int y=0; y < 39; y++)
    //      readLine(y);

    GD.fill(RAM_PIC, 0xDB, 0x0FFF);  // Zero all character RAM with white
    
    
    
    addr= GET_FAR_ADDRESS(fullascii);
    
  }

  void draw()
  {
    /* scroll up */
    if (nextLine<linesToScroll) 
    {
      GD.wr16(SCROLL_Y, yscroll++); 
      GD.waitvblank();

      if (eight==8)
      {
        if (screenLine > 63) 
        {
          screenLine=0;
        }

        // put new line on screen
        readLine(screenLine++); 
        nextLine++;
        eight=0;
      }
      eight++;
    }
    else
    {

    }
  }

private:  
    uint32_t addr;

  int yscroll;
  int asciiCount;  // ascii file byte index
  int nextLine;
  int screenLine;
  int eight;
  int linesToScroll;

  // get a line from ascii at y pos.  from ascii y,  to screen y
  void readLine(int destY){
    char msg[52];
    memset(msg, 32, sizeof(msg)); // make a empty row with ascii chr 32=space
    char cc=0;
    int x = 0;

    while (cc!=10 &  asciiCount < fullasciiSize-1  ){
      
      
      
      

      cc = getByte(addr + asciiCount++);
      
      
      msg[x] = cc;

      if (cc==10 || cc==13) msg[x]=32;
      x++;
    }

    putascii( 0,  destY, msg);  // write row to screen
  }

  // put an array of chars on screen
  void putascii(int x, int y, const char *s)
  {
    GD.__wstart((y << 6) + x);
    while (*s)
      SPI.transfer((*s++));
    GD.__end();
  }

  // put a single char on screen
  void putascii(int x, int y, char s)
  {
    GD.__wstart((y << 6) + x);
    SPI.transfer(s);
    GD.__end();
  }

};





