/*

 Name      :  LFT Chiptune player
 Notes     :  LFT's hardware chiptune project
 
 music by subi. we ended up using a MOD engine so we scrapped this engine.
 
 */

#include "songdata.h"
#define SOUNDBUFFERHI 0x3f00
#define SOUNDBUFFERLO 0x4000

static int line;

struct active {
  byte instrument;
  uint32_t addr;
  uint16_t pos, length;
  uint16_t x, y;
};
#define NACTIVE 3
static active playing[NACTIVE];

struct active *findidle()
{
  byte i;
  for (i = 0; i < NACTIVE; i++)
    if (playing[i].addr == 0)
      return &playing[i];
  return NULL;
}



#define TRACKLEN 32

// lft song
#define MAXTRACK	0x92
#define SONGLEN		0x37

// subi song
//#define MAXTRACK	0x24
//#define SONGLEN		0x84


#include <avr/pgmspace.h>

volatile u8 callbackwait;
volatile u8 lastsample;
volatile u8 timetoplay;
volatile u8 test;
volatile u8 testwait;
u8 trackwait;
u8 trackpos;
u8 playsong;
u8 songpos;
u32 noiseseed = 1;
u8 light[2];
int globalBuffer;

const u16 freqtable[] = {
  0x010b, 0x011b, 0x012c, 0x013e, 0x0151, 0x0165, 0x017a, 0x0191, 0x01a9,
  0x01c2, 0x01dd, 0x01f9, 0x0217, 0x0237, 0x0259, 0x027d, 0x02a3, 0x02cb,
  0x02f5, 0x0322, 0x0352, 0x0385, 0x03ba, 0x03f3, 0x042f, 0x046f, 0x04b2,
  0x04fa, 0x0546, 0x0596, 0x05eb, 0x0645, 0x06a5, 0x070a, 0x0775, 0x07e6,
  0x085f, 0x08de, 0x0965, 0x09f4, 0x0a8c, 0x0b2c, 0x0bd6, 0x0c8b, 0x0d4a,
  0x0e14, 0x0eea, 0x0fcd, 0x10be, 0x11bd, 0x12cb, 0x13e9, 0x1518, 0x1659,
  0x17ad, 0x1916, 0x1a94, 0x1c28, 0x1dd5, 0x1f9b, 0x217c, 0x237a, 0x2596,
  0x27d3, 0x2a31, 0x2cb3, 0x2f5b, 0x322c, 0x3528, 0x3851, 0x3bab, 0x3f37,
  0x42f9, 0x46f5, 0x4b2d, 0x4fa6, 0x5462, 0x5967, 0x5eb7, 0x6459, 0x6a51,
  0x70a3, 0x7756, 0x7e6f
};

/*
const u16 freqtable[] = {
 0x0085, 0x008d, 0x0096, 0x009f, 0x00a8, 0x00b2, 0x00bd, 0x00c8, 0x00d4,
 0x00e1, 0x00ee, 0x00fc, 0x010b, 0x011b, 0x012c, 0x013e, 0x0151, 0x0165,
 0x017a, 0x0191, 0x01a9, 0x01c2, 0x01dd, 0x01f9, 0x0217, 0x0237, 0x0259,
 0x027d, 0x02a3, 0x02cb, 0x02f5, 0x0322, 0x0352, 0x0385, 0x03ba, 0x03f3,
 0x042f, 0x046f, 0x04b2, 0x04fa, 0x0546, 0x0596, 0x05eb, 0x0645, 0x06a5,
 0x070a, 0x0775, 0x07e6, 0x085f, 0x08de, 0x0965, 0x09f4, 0x0a8c, 0x0b2c,
 0x0bd6, 0x0c8b, 0x0d4a, 0x0e14, 0x0eea, 0x0fcd, 0x10be, 0x11bd, 0x12cb,
 0x13e9, 0x1518, 0x1659, 0x17ad, 0x1916, 0x1a94, 0x1c28, 0x1dd5, 0x1f9b,
 0x217c, 0x237a, 0x2596, 0x27d3, 0x2a31, 0x2cb3, 0x2f5b, 0x322c, 0x3528,
 0x3851, 0x3bab, 0x3f37
 };
 */

const s8 sinetable[] = {
  0, 12, 25, 37, 49, 60, 71, 81, 90, 98, 106, 112, 117, 122, 125, 126,
  127, 126, 125, 122, 117, 112, 106, 98, 90, 81, 71, 60, 49, 37, 25, 12,
  0, -12, -25, -37, -49, -60, -71, -81, -90, -98, -106, -112, -117, -122,
  -125, -126, -127, -126, -125, -122, -117, -112, -106, -98, -90, -81,
  -71, -60, -49, -37, -25, -12
};

const u8 validcmds[] = "0dfijlmtvw~+=";

enum {
  WF_TRI,
  WF_SAW,
  WF_PUL,
  WF_NOI
};

volatile struct oscillator {
  u16	freq;
  u16	phase;
  u16	duty;
  u8	waveform;
  u8	volume;	// 0-255
} 
osc[4];

struct trackline {
  u8	note;
  u8	instr;
  u8	cmd[2];
  u8	param[2];
};

struct track {
  struct trackline	line[TRACKLEN];
};

struct unpacker {
  u16	nextbyte;
  u8	buffer;
  u8	bits;
};

struct lftchannel {
  struct unpacker		trackup;
  u8			tnum;
  s8			transp;
  u8			tnote;
  u8			lastinstr;
  u8			inum;
  u16			iptr;
  u8			iwait;
  u8			inote;
  s8			bendd;
  s16			bend;
  s8			volumed;
  s16			dutyd;
  u8			vdepth;
  u8			vrate;
  u8			vpos;
  s16			inertia;
  u16			slur;
} 
lftchannel[4];

u16 resources[16 + MAXTRACK];

struct unpacker songup;

byte readlftsongbyte(u16 offset)
{

  return pgm_read_byte_near(&songdata[0] + offset); 
}

void initup(struct unpacker *up, u16 offset) {
  up->nextbyte = offset;
  up->bits = 0;
}

u8 readbit(struct unpacker *up) {
  u8 val;

  if(!up->bits) {
    up->buffer = readlftsongbyte(up->nextbyte++);
    up->bits = 8;
  }

  up->bits--;
  val = up->buffer & 1;
  up->buffer >>= 1;

  return val;
}

u16 readchunk(struct unpacker *up, u8 n) {
  u16 val = 0;
  u8 i;

  for(i = 0; i < n; i++) {
    if(readbit(up)) {
      val |= (1 << i);
    }
  }

  return val;
}

void readinstr(byte num, byte pos, byte *dest) {
  dest[0] = readlftsongbyte(resources[num] + 2 * pos + 0);
  dest[1] = readlftsongbyte(resources[num] + 2 * pos + 1);
}

void runcmd(u8 ch, u8 cmd, u8 param) {
  switch(validcmds[cmd]) {
  case '0':
    lftchannel[ch].inum = 0;
    break;
  case 'd':
    osc[ch].duty = param << 8;
    break;
  case 'f':
    lftchannel[ch].volumed = param;
    break;
  case 'i':
    lftchannel[ch].inertia = param << 1;
    break;
  case 'j':
    lftchannel[ch].iptr = param;
    break;
  case 'l':
    lftchannel[ch].bendd = param;
    break;
  case 'm':
    lftchannel[ch].dutyd = param << 6;
    break;
  case 't':
    lftchannel[ch].iwait = param;
    break;
  case 'v':
    osc[ch].volume = param;
    break;
  case 'w':
    osc[ch].waveform = param;
    break;
  case '+':
    lftchannel[ch].inote = param + lftchannel[ch].tnote - 12 * 4;
    break;
  case '=':
    lftchannel[ch].inote = param;
    break;
  case '~':
    if(lftchannel[ch].vdepth != (param >> 4)) {
      lftchannel[ch].vpos = 0;
    }
    lftchannel[ch].vdepth = param >> 4;
    lftchannel[ch].vrate = param & 15;
    break;
  }
}

void playroutine() {			// called at 50 Hz
  u8 ch;
  u8 lights;

  if(playsong) {
    if(trackwait) {
      trackwait--;
    } 
    else {
      trackwait = 4;

      if(!trackpos) {
        if(playsong) {
          if(songpos >= SONGLEN) {
            playsong = 0;
          } 
          else {
            for(ch = 0; ch < 4; ch++) {
              u8 gottransp;
              u8 transp;

              gottransp = readchunk(&songup, 1);
              lftchannel[ch].tnum = readchunk(&songup, 6);
              if(gottransp) {
                transp = readchunk(&songup, 4);
                if(transp & 0x8) transp |= 0xf0;
              } 
              else {
                transp = 0;
              }
              lftchannel[ch].transp = (s8) transp;
              if(lftchannel[ch].tnum) {
                initup(&lftchannel[ch].trackup, resources[16 + lftchannel[ch].tnum - 1]);
              }
            }
            songpos++;
          }
        }
      }

      if(playsong) {
        for(ch = 0; ch < 4; ch++) {
          if(lftchannel[ch].tnum) {
            u8 note, instr, cmd, param;
            u8 fields;

            fields = readchunk(&lftchannel[ch].trackup, 3);
            note = 0;
            instr = 0;
            cmd = 0;
            param = 0;
            if(fields & 1) note = readchunk(&lftchannel[ch].trackup, 7);
            if(fields & 2) instr = readchunk(&lftchannel[ch].trackup, 4);
            if(fields & 4) {
              cmd = readchunk(&lftchannel[ch].trackup, 4);
              param = readchunk(&lftchannel[ch].trackup, 8);
            }
            if(note) {
              lftchannel[ch].tnote = note + lftchannel[ch].transp;
              if(!instr) instr = lftchannel[ch].lastinstr;
            }
            if(instr) {
              if(instr == 2) light[1] = 5;
              if(instr == 1) {
                light[0] = 5;
                if(lftchannel[ch].tnum == 4) {
                  light[0] = light[1] = 3;
                }
              }
              if(instr == 7) {
                light[0] = light[1] = 30;
              }
              lftchannel[ch].lastinstr = instr;
              lftchannel[ch].inum = instr;
              lftchannel[ch].iptr = 0;
              lftchannel[ch].iwait = 0;
              lftchannel[ch].bend = 0;
              lftchannel[ch].bendd = 0;
              lftchannel[ch].volumed = 0;
              lftchannel[ch].dutyd = 0;
              lftchannel[ch].vdepth = 0;
            }
            if(cmd) runcmd(ch, cmd, param);
          }
        }

        trackpos++;
        trackpos &= 31;
      }
    }
  }

  for(ch = 0; ch < 4; ch++) {
    s16 vol;
    u16 duty;
    u16 slur;

    while(lftchannel[ch].inum && !lftchannel[ch].iwait) {
      u8 il[2];

      readinstr(lftchannel[ch].inum, lftchannel[ch].iptr, il);
      lftchannel[ch].iptr++;

      runcmd(ch, il[0], il[1]);
    }
    if(lftchannel[ch].iwait) lftchannel[ch].iwait--;

    if(lftchannel[ch].inertia) {
      s16 diff;

      slur = lftchannel[ch].slur;
      diff = freqtable[lftchannel[ch].inote] - slur;
      //diff >>= lftchannel[ch].inertia;
      if(diff > 0) {
        if(diff > lftchannel[ch].inertia) diff = lftchannel[ch].inertia;
      } 
      else if(diff < 0) {
        if(diff < -lftchannel[ch].inertia) diff = -lftchannel[ch].inertia;
      }
      slur += diff;
      lftchannel[ch].slur = slur;
    } 
    else {
      slur = freqtable[lftchannel[ch].inote];
    }
    osc[ch].freq =
      slur +
      lftchannel[ch].bend +
      ((lftchannel[ch].vdepth * sinetable[lftchannel[ch].vpos & 63]) >> 2);
    lftchannel[ch].bend += lftchannel[ch].bendd;
    vol = osc[ch].volume + lftchannel[ch].volumed;
    if(vol < 0) vol = 0;
    if(vol > 255) vol = 255;
    osc[ch].volume = vol;

    duty = osc[ch].duty + lftchannel[ch].dutyd;
    if(duty > 0xe000) duty = 0x2000;
    if(duty < 0x2000) duty = 0xe000;
    osc[ch].duty = duty;

    lftchannel[ch].vpos += lftchannel[ch].vrate;
  }

  lights = 0;
  if(light[0]) {
    light[0]--;
    lights |= 0x02;
  }
  if(light[1]) {
    light[1]--;
    lights |= 0x10;
  }
  //	PORTC = lights;
}

void initresources() {
  u8 i;
  struct unpacker up;

  initup(&up, 0);
  for(i = 0; i < 16 + MAXTRACK; i++) {
    resources[i] = readchunk(&up, 13);
  }

  initup(&songup, resources[0]);
}


byte lftwritepointer = 0;
void fillLFTSampleBuffer(){

  playroutine();
  byte readpointer = GD.rd(COMM+0);
  byte fullness = lftwritepointer - readpointer;

  while (fullness < 254  ) {
    // if (fullness&1)
    //  {

    fillLFTSample();
    //  }      
    GD.wr(SOUNDBUFFERHI + lftwritepointer, highByte(globalBuffer));               
    lftwritepointer++;
    fullness++;
  }
}


//At the 8KHz rate, 254 samples is enough for 31 milliseconds of sound. 
//So if a game refills the sample buffer at least once during every 36 Hz frame, the audio playback will be continuous.
void fillLFTSample(){
  u8 i;
  s16 acc;
  u8 newbit;

  newbit = 0;
  if(noiseseed & 0x80000000L) newbit ^= 1;
  if(noiseseed & 0x01000000L) newbit ^= 1;
  if(noiseseed & 0x00000040L) newbit ^= 1;
  if(noiseseed & 0x00000200L) newbit ^= 1;
  noiseseed = (noiseseed << 1) | newbit;

  /*
  if(callbackwait) {
   callbackwait--;
   } 
   else {
   timetoplay++;
   callbackwait = 180 - 1;
   }
   */

  acc = 0;
  for(i = 0; i < 4; i++) {
    s8 value; // [-32,31]

    switch(osc[i].waveform) {
    case WF_TRI:
      if(osc[i].phase < 0x8000) {
        value = -32 + (osc[i].phase >> 9);
      } 
      else {
        value = 31 - ((osc[i].phase - 0x8000) >> 9);
      }
      break;
    case WF_SAW:
      value = -32 + (osc[i].phase >> 10);
      break;
    case WF_PUL:
      value = (osc[i].phase > osc[i].duty)? -32 : 31;
      break;
    case WF_NOI:
      value = (noiseseed & 63) - 32;
      break;
    default:
      value = 0;
      break;
    }
    osc[i].phase += osc[i].freq;

    acc += value * osc[i].volume; // rhs = [-8160,7905]
  }
  // acc [-32640,31620]
  // lastsample = 128 + (acc >> 8);	// [1,251]


  //noInterrupts();
  //    GD.wr16(SAMPLE_R, acc);
  //    GD.wr16(SAMPLE_L, acc);

  //  lastsample =  128+(acc >> 8);

  globalBuffer = acc;
}


void initSong(){

  //  GD.microcode(soundbuffer_code, sizeof(soundbuffer_code));

  timetoplay = 0;
  trackwait = 0;
  trackpos = 0;
  playsong = 1;
  songpos = 0;

  osc[0].volume = 0;
  lftchannel[0].inum = 0;
  osc[1].volume = 0;
  lftchannel[1].inum = 0;
  osc[2].volume = 0;
  lftchannel[2].inum = 0;
  osc[3].volume = 0;
  lftchannel[3].inum = 0;
  initresources();


  // 1 initialaze set to 83 is 8000Hz
  // multiply by 250 to get 32Hz
  // multiply by 160 to get 50Hz
  // higher numbers are slower 170

  // configure the 16 bit hardware timer on the ATmega168/328
  Timer1.initialize(63*180);         // initialize timer1, and set the period in microseconds. 

  //  Timer1.initialize(13000);         // for subi song    
  Timer1.attachInterrupt(fillLFTSampleBuffer);  // attaches callback() as a timer overflow interrupt

}

