

class Julia
{
public:
  Julia(){
    
    memset(fire_buffer, 0, sizeof(fire_buffer) );
  
    generate_332_palette();  

    frameCount=0;

    // dimensions
    w = RENDERWIDTH;
    h= RENDERHEIGHT;
    rw=(RENDERWIDTH/2);
    rh=(RENDERHEIGHT/2);
    l42 = (RENDERWIDTH * RENDERHEIGHT) -1;
    j5 = int(4 * -(RENDERWIDTH >> 1)+ RENDERWIDTH+ rw);
    l5 = int(4 * -(RENDERHEIGHT >> 1)+ RENDERHEIGHT+rh);


    // multiply lookup table
    //  sqr = new int[2048];
    //  for(int i = 0; i < 2048; i++){
    //    sqr[i] = ((i*i) / 256);
    //  }

    // sin lookup table
    //  n = new int[sqr.length];
    for(int l1 = 0; l1 < 2048; l1++) {
      //        n[l1] = (int)(double)(65535 * sin( ( ((double)l1 * PI) / (double)512)) * 256)>>16  ;
      //    n[l1] = (int)(double)(65535 * sin( ( ((double)l1 * PI) / (double)512)) * 256)>>16  ;

      n[l1] = (int)(sin(l1/1024.0*PI*2)*255.0+255.0)-255 ;    
      //    n[l1] = (int)(sin(l1/1024.0*PI*2)*127.0+127.0)-127 ;        
    }

    // generate color palette in RGB.
    //  palette = new color[32];
    for(byte i=0; i<32; i++) {
      palette[i]  = color(atan(i*.2)*255,0,sin(i*.4)*255);      // Black to red
      //    palette[i]  = color(0,255,0);      // Black to red    
    }

  }

  void draw(){
    int j = frameCount++<<5;

    int j10 = (n[j  & 0x7ff] ) ;
    int k10 = (n[j >> 1 & 0x7ff] ) ;

//    int k4 = 0;
//    int l4 = l42;


    int k4 = RENDERWIDTH;
    int l4 = l42-RENDERWIDTH*2;

    for(int y = l5; y < 0; y++)
    {
      for(int x = j5; x < rw; x++)
      {
        long k9 = x<<4; // left shift when going smaller
        long l9 = y<<4;
        int i=0;
        for (; i<6; i++) {

          //        int k9Sq = sqr[(k9 < 0) ? -k9 : k9]; // faster than Math.abs(k9)
          //        int l9Sq = sqr[(l9 < 0) ? -l9 : l9]; // faster than Math.abs(l9)
          long k9Sq = (k9*k9)>>8; 
          long l9Sq = (l9*l9)>>8; 
          if ( k9Sq + l9Sq > 1024 ) break;

          long i9 = k9;
          long j9 = l9;
          k9 = (k9Sq  - l9Sq)+ j10;
          l9 = ( (i9 * j9)  >> 7)+ k10;
        }                   
        int fractalPixel = palette[i];
        fire_buffer[k4++] = fractalPixel; //top half
        fire_buffer[l4--] = fractalPixel; //bottom half
      }
    }
  }

private:  
  int n[2048];
  long l42;
  long j5;
  long l5;

  /* use defines of RENDER WIDTH*/
  int rh;
  int rw;
  int h;
  int w;

  // colors
  byte palette[32];
  int frameCount;
};




