/*

 Name      :  Sound effect player
 Notes     :  mix in 8Khz wav samples into the audio buffer
 
 played uncompressed wav data
 
 */




static byte sampleWritePos;
const static char *sampleStart0, *samplePos0, *sampleEnd0;
const static char *sampleStart1, *samplePos1, *sampleEnd1;
const static char *sampleStart2, *samplePos2, *sampleEnd2;
const static char *sampleStart3, *samplePos3, *sampleEnd3;
static boolean repeatSample0, repeatSample1, repeatSample2, repeatSample3;

static void writeSamples(byte num)
{
  if (num > 0) {
    //    GD.__wstart(Coprocessor::samplePage()+sampleWritePos);
    const char *s0=samplePos0, *se0=sampleEnd0;
    const char *s1=samplePos1, *se1=sampleEnd1;
    const char *s2=samplePos2, *se2=sampleEnd2;
    const char *s3=samplePos3, *se3=sampleEnd3;
    for (byte i=0; i<num; ++i) {
      // Add together the four sound channels
      //
      // This could be optimized for when there are less
      // than four active channels but at the moment it
      // only takes about four raster lines per frame so
      // sum the channels so I didn't bother.
      int val = 0;
      if (s0) {
        val += (char)pgm_read_byte_near(s0++);
        if (s0 == se0) {
          s0 = (repeatSample0)? sampleStart0: 0;
        }
      }
      if (s1) {
        val += (char)pgm_read_byte_near(s1++);
        if (s1 == se1) {
          s1 = (repeatSample1)? sampleStart1: 0;
        }
        sampleleft=val;
        sampleright=val;
      }
      if (s2) {
        val += (char)pgm_read_byte_near(s2++);
        if (s2 == se2) {
          s2 = (repeatSample2)? sampleStart2: 0;
        }
      }
      if (s3) {
        val += (char)pgm_read_byte_near(s3++);
        if (s3 == se3) {
          s3 = (repeatSample3)? sampleStart3: 0;
        }
      }
      //      SPI.transfer(val>>2);
    }
    //    GD.__end();
    samplePos0 = s0;
    samplePos1 = s1;
    samplePos2 = s2;  
    samplePos3 = s3;
    sampleWritePos += num;
  }
}

// STart a sample playing
void playSample(const char *s, int n, byte ch)
{
  bool repeat = (n < 0);
  if (repeat) {
    n = -n;
  }
  switch (ch) {
  case 0:   
    sampleStart0 = s;
    samplePos0 = s;
    sampleEnd0 = s+n;
    repeatSample0 = repeat;
    break;
  case 1:   
    sampleStart1 = s;
    samplePos1 = s;
    sampleEnd1 = s+n;
    repeatSample1 = repeat;
    break;
  case 2:   
    sampleStart2 = s;
    samplePos2 = s;
    sampleEnd2 = s+n;
    repeatSample2 = repeat;
    break;
  case 3:   
    sampleStart3 = s;
    samplePos3 = s;
    sampleEnd3 = s+n;
    repeatSample3 = repeat;
    break;
  }
}

