/*

 Name      :  Tile Menu
 Notes     :  tile map and text overlays
 
 */


// MENU
#define ACS_ULCORNER	0x07	/* upper left corner 7*/
#define ACS_LLCORNER	0x00	/* lower left corner */
#define ACS_URCORNER	0x09	/* upper right corner */
#define ACS_LRCORNER	0x02	/* lower right corner */
#define ACS_HLINETOP	0x08	/* horizontal line */
#define ACS_HLINE	0x01	/* horizontal line */
#define ACS_VLINE	0x06	/* vertical line */
#define ACS_VLINERIGHT	0x05	/* vertical line */
#define ACS_LMENUON	0x03	/* vertical line */
#define ACS_RMENUON	0x04	/* vertical line */
#define ACS_LMENUOFF	0x0A	/* vertical line */
#define ACS_RMENUOFF	0x0B	/* vertical line */

// MAIN PLAYER
#define PLAYER_DOWN_1         8
#define PLAYER_DOWN_2         9
#define PLAYER_UP_1           2
#define PLAYER_UP_2           3
#define PLAYER_LEFT_1         4
#define PLAYER_LEFT_2         5
#define PLAYER_RIGHT_1        6
#define PLAYER_RIGHT_2        7

// RED GUY
#define SCENER1_DOWN_1         8+14
#define SCENER1_DOWN_2         9+14
#define SCENER1_UP_1           2+14
#define SCENER1_UP_2           3+14
#define SCENER1_LEFT_1         4+14
#define SCENER1_LEFT_2         5+14
#define SCENER1_RIGHT_1        6+14
#define SCENER1_RIGHT_2        7+14

// ALIEN
#define ALIEN_DOWN_1         14
#define ALIEN_DOWN_2         15
#define ALIEN_UP_1           12
#define ALIEN_UP_2           13
#define ALIEN_LEFT_1         10 
#define ALIEN_LEFT_2         11 
#define ALIEN_RIGHT_1        0
#define ALIEN_RIGHT_2        1

// SPRITE MOVEMENT
#define UP      0
#define RIGHT   1
#define DOWN    2
#define LEFT    3
#define SPEED               8   // how many pixels link moves each game loop
#define FOOT_COUNT_MAX      0   // how many pixels before switching walking sprite


int textoffset=-(48*2)-1-32;

const PROGMEM char sayText[][32] = {
  "My prod isn't finished yet...",
  "Amiiigaaa!",
  "Someone stole my vote-disc!",
  "That's so 1995.",
  "The Scene is dead.",
  "My Amiga broke.",
  "These are coder colors.",
  "Link me beautiful.",
  "@Party is going to be awesome!",
  "Scheisse!"
};

const static char *mainmenu[] = 
{ 
  "Talk",
  "Look",
  "Effects",
  "Battle",  
  0
};

const static char *submenu1[] = 
{ 
  "Groovy Cube",
  "Hot Scroller",
  "Twister",
  "Copper Craze",
  "Fractalishious",  
  "3D Cube",    
  "3D DNA",    
  "3D Chicken", 
  "RotoZoooom",  
  "Metaballs",  

  0
};

const static char *submenu2[]= 
{ 
  "Giant cube",
  "Chicken with tophat",
  "DNA",
  "Floppy disk",  
  0
};

const static char *submenu3[] = 
{ 
  "Do nothing 1",
  "Do nothing 2",
  "Do nothing 3",
  "Enter new submenu...",
  0
};


static PROGMEM prog_uchar sprite_player_sprimg[] = {

0xc9,  0x81,  0x39,  0xf8,  0x0f,  0xe0,  0x41,  0x3e,  0xa4,  0xb8,  0x0b,  0x00,  0x61,  0x3f,  0x58,  0x13, 
0x51,  0x15,  0xd6,  0x83,  0x81,  0x2a,  0x11,  0xaa,  0x20,  0x52,  0x8d,  0xa0,  0xc1,  0x50,  0x04,  0x11, 
0x22,  0x66,  0x02,  0x41,  0x8c,  0x09,  0x8e,  0x88,  0x20,  0x22,  0x42,  0x44,  0x44,  0x26,  0xc4,  0x20, 
0x90,  0x10,  0xdd,  0x51,  0x0d,  0xce,  0x88,  0xa8,  0xca,  0x04,  0x10,  0x14,  0x82,  0x77,  0xd4,  0x08, 
0x8e,  0xe1,  0x21,  0x05,  0x04,  0x8e,  0xf0,  0x11,  0x1e,  0x82,  0x67,  0x08,  0x4c,  0x06,  0xa1,  0x92, 
0x48,  0xf0,  0x0a,  0x8e,  0x01,  0x23,  0x5a,  0xb8,  0x4b,  0x19,  0x76,  0x33,  0x64,  0x6e,  0x08,  0x86, 
0x01,  0x43,  0x69,  0xfe,  0x0c,  0x12,  0xf1,  0x25,  0x05,  0x88,  0x50,  0x11,  0x2e,  0x4a,  0x64,  0x76, 
0x4a,  0x8f,  0x65,  0x23,  0x6f,  0x64,  0x87,  0x04,  0x90,  0x6f,  0x82,  0x93,  0x38,  0x72,  0x44,  0x29, 
0x29,  0x71,  0x12,  0xa2,  0xab,  0x96,  0x4c,  0x5a,  0xe2,  0xd4,  0x39,  0x75,  0x29,  0x85,  0x88,  0x14, 
0x93,  0xc5,  0x2b,  0x4e,  0x07,  0x6c,  0x79,  0x0d,  0xce,  0xbd,  0x7a,  0xf3,  0xea,  0xdd,  0x0f,  0x59, 
0x7f,  0x01,  0xc0,  0xbd,  0x7c,  0xf9,  0xf4,  0xe5,  0x9b,  0x77,  0x1f,  0x24,  0x83,  0x97,  0x27,  0x7f, 
0xee,  0xd4,  0xd1,  0x93,  0x47,  0x4e,  0x9e,  0xbb,  0x60,  0x11,  0xbc,  0x3d,  0xfa,  0xf2,  0xe1,  0x54, 
0x0a,  0x14,  0x29,  0x4e,  0x5d,  0xf8,  0x0a,  0x13,  0xe1,  0x2b,  0x38,  0x78,  0x51,  0xa4,  0x08,  0x11, 
0x24,  0x4d,  0x5e,  0xbc,  0x78,  0xf5,  0x15,  0x11,  0xbd,  0x06,  0x0e,  0x47,  0x8a,  0x2c,  0x29,  0x44, 
0x28,  0xd0,  0x51,  0x08,  0x08,  0x3e,  0x8e,  0x1c,  0x59,  0x0a,  0x00,  0x16,  0x15,  0x3a,  0xf2,  0x14, 
0x01,  0xbc,  0xa6,  0x8b,  0xe0,  0x19,  0x1c,  0x39,  0x59,  0x52,  0x14,  0x3c,  0x63,  0x44,  0xb6,  0xf0, 

0xe5,  0xd5,  0x89,  0x15,  0x44,  0x56,  0x14,  0x71,  0xe1,  0xe4,  0x24,  0x01,  0x86,  0x4f,  0x7f,  0x3e, 
0x9d,  0x5a,  0x81,  0x82,  0x44,  0x89,  0x15,  0x2e,  0xc1,  0x23,  0x3a,  0x16,  0x2f,  0x97,  0x4a,  0x91, 
0x42,  0xe1,  0xca,  0x45,  0xa9,  0x93,  0x68,  0x58,  0x41,  0x9c,  0x2a,  0x81,  0x8a,  0x04,  0xaa,  0x92, 
0xe0,  0xea,  0xdf,  0x57,  0xae,  0x70,  0x29,  0x55,  0x28,  0x55,  0xa7,  0x45,  0xb0,  0x7c,  0xfb,  0x4c, 
0x00,  0xe6,  0x4c,  0xc9,  0xa0,  0x45,  0x4f,  0xa5,  0x4b,  0x2f,  0x21,  0xa8,  0x51,  0xba,  0x33,  0xa7, 
0xae,  0x21,  0x90,  0x82,  0xa5,  0x34,  0x79,  0x77,  0x27,  0xf3,  0xe2,  0xdb,  0x05,  0x3d,  0x73,  0x2d, 
0x20,  0xb8,  0x3c,  0x28,  0x33,  0xaa,  0xbe,  0x7d,  0x70,  0x94,  0x29,  0xf3,  0x5a,  0x98,  0x09,  0xe1, 
0x1f,  0x90,  0xa8,  0x48,  0x28,  0x27,  0x20,  0x82,  0x4d,  0x0b,  0x77,  0x34,  0x21,  0x92,  0x5c,  0x03, 
0x33,  0x36,  0x38,  0xf0,  0x57,  0x05,  0xcb,  0x12,  0x44,  0xd5,  0xf6,  0x17,  0x4a,  0x70,  0xb4,  0x67, 
0x0b,  0x2d,  0x2c,  0x44,  0x36,  0xec,  0xf1,  0x0f,  0x3e,  0xfc,  0xed,  0xdb,  0xb3,  0x6e,  0x37,  0x00, 
0xd8,  0xb2,  0x67,  0x3f,  0x04,  0xbb,  0x87,  0x8f,  0xde,  0x9d,  0xad,  0xe0,  0x61,  0x9d,  0x97,  0x3b, 
0xf4,  0xf0,  0x83,  0x37,  0x7a,  0xfe,  0xea,  0x6c,  0x59,  0xb7,  0xc4,  0x9d,  0x97,  0x3a,  0xfe,  0xe8, 
0xc3,  0x77,  0x60,  0x70,  0x67,  0xdd,  0x16,  0x27,  0x8b,  0xdc,  0xd5,  0xa1,  0x4b,  0x60,  0xe1,  0x83, 
0x7b,  0x08,  0xe0,  0xa8,  0x1c,  0xea,  0x45,  0xe5,  0xff,  0x32,  0x9c,  0x3a,  0x77,  0xe5,  0xdc,  0x21, 
0x44,  0xa9,  0x25,  0x4c,  0x9c,  0x52,  0x15,  0x42,  0x3b,  0x42,  0x70,  0xfb,  0x08,  0x22,  0xa9,  0x1a, 
0x55,  0x25,  0xee,  0x85,  0x3d,  0x08,  0x93,  0x2a,  0x89,  0x9a,  0x14,  0xd3,  0x11,  0x82,  0xff,  0x43, 

0xf0,  0x62,  0x46,  0x0c,  0x99,  0xe0,  0xdf,  0xff,  0xfb,  0x7f,  0xff,  0xef,  0x7f,  0xc3,  0x81,  0x48, 
0xff,  0x9f,  0xc0,  0x10,  0x87,  0xc3,  0xf0,  0x5f,  0x08,  0xba,  0x75,  0x23,  0x82,  0xa8,  0x7b,  0xfe, 
0x4f,  0x0f,  0xdd,  0x98,  0x43,  0x80,  0x88,  0x15,  0xbe,  0x3f,  0x30,  0x07,  0x40,  0xdd,  0xcb,  0xdf, 
0x9f,  0x63,  0xcd,  0xc1,  0x3f,  0xf8,  0x68,  0xc2,  0x8c,  0x1a,  0xb3,  0xe6,  0xf5,  0x1f,  0x3e,  0x30, 
0x6a,  0x42,  0x0d,  0x19,  0xf3,  0xfa,  0x7b,  0x10,  0xae,  0x35,  0x61,  0xd4,  0x8e,  0x18,  0x36,  0x3f, 
0xfa,  0xe7,  0xdf,  0x35,  0x45,  0x4c,  0x1a,  0x79,  0xc3,  0x87,  0x1f,  0xc2,  0x8f,  0x87,  0x08,  0xaa, 
0xc7,  0x21,  0xfc,  0xbb,  0x93,  0x43,  0x87,  0xa6,  0x52,  0xa7,  0xbe,  0xde,  0x9d,  0x7b,  0x79,  0x72, 
0x68,  0xc9,  0x33,  0xa5,  0xc4,  0xa0,  0xaf,  0xfb,  0xe7,  0x0e,  0x0e,  0x09,  0x33,  0xe6,  0x8c,  0x9a, 
0x09,  0x7f,  0xff,  0xff,  0xff,  0xff,  0xff,  0xff,  0x47,  0x45,  0x06,  0xc1,  0xff,  0xbf,  0x3c,  0x7c, 
0x6f,  0x05,  0x88,  0x52,  0xfa,  0x47,  0xfa,  0x0d,  0x0e,  0x9e,  0x75,  0x6b,  0x44,  0xdb,  0x3f,  0x3c, 
0xfb,  0x0e,  0xc1,  0xc1,  0xb1,  0x7d,  0x68,  0xd2,  0x88,  0x48,  0xb0,  0x63,  0xcf,  0xc1,  0x27,  0x38, 
0xb8,  0xd3,  0xcc,  0x58,  0x73,  0x00,  0x70,  0xe7,  0x39,  0x04,  0xef,  0x03,  0x47,  0xba,  0x19,  0x6b, 
0xd0,  0xa8,  0x41,  0xb3,  0x6b,  0x4f,  0x1e,  0x83,  0xb7,  0x27,  0xe7,  0x8c,  0x11,  0x07,  0x8b,  0xe0, 
0xe1,  0xd8,  0xbb,  0xa7,  0xf0,  0xed,  0x3d,  0x7c,  0x40,  0x40,  0xac,  0x31,  0x04,  0x38,  0xf6,  0xe4, 
0x3d,  0x85,  0x38,  0xd7,  0x8d,  0x18,  0x32,  0xe7,  0xf8,  0xe1,  0x3a,  0x3a,  0x57,  0x4f,  0xef,  0xeb, 
0x03,  0x72,  0x88,  0xd0,  0x9d,  0x04,  0x7c,  0x96,  0x30,  0x17,  0xb2,  0x44,  0xd1,  0x70,  0xe5,  0x2f, 

0xb8,  0x55,  0x0f,  0x13,  0x46,  0xe5,  0xd0,  0xa0,  0xa1,  0x6e,  0xfe,  0xf9,  0x77,  0xd3,  0x0f,  0xdc, 
0xa8,  0x20,  0x05,  0x47,  0x7d,  0x87,  0x73,  0x6f,  0x5e,  0xbc,  0x19,  0x17,  0x54,  0xcc,  0x84,  0xff, 
0xfe,  0xdf,  0xff,  0xff,  0xff,  0x78,  0x25,  0x2a,  0x12,  0x4a,  0xff,  0x5f,  0x1e,  0xfa,  0xb7,  0x07, 
0x44,  0x92,  0xff,  0xe3,  0xfc,  0x06,  0x07,  0xfd,  0xba,  0x61,  0x5b,  0xfa,  0x1f,  0x81,  0x21,  0x04, 
0x07,  0x47,  0x7d,  0xba,  0x51,  0xc3,  0x46,  0xa4,  0x43,  0x5f,  0xf0,  0x0f,  0x1e,  0x01,  0x80,  0x35, 
0xeb,  0xe0,  0x11,  0x81,  0xdd,  0xc3,  0x47,  0x5f,  0x3f,  0x74,  0x6b,  0x0b,  0x09,  0xee,  0xd0,  0xc3, 
0x0f,  0xde,  0xe8,  0xf9,  0x87,  0x4f,  0x4d,  0xc1,  0x43,  0x1f,  0x7f,  0xf4,  0xe1,  0x3b,  0x30,  0x84, 
0xcf,  0x05,  0x10,  0x3c,  0xd0,  0xf1,  0x4f,  0x21,  0xe1,  0x2b,  0x04,  0x6a,  0x87,  0xda,  0x42,  0xf9, 
0xe7,  0x05,  0xa7,  0xae,  0x5d,  0x3b,  0x77,  0x08,  0x51,  0x6a,  0xf3,  0x13,  0xa7,  0x54,  0x85,  0x50, 
0x75,  0xa7,  0xe0,  0xfe,  0x8b,  0xa4,  0x6a,  0x54,  0x95,  0xb8,  0xf6,  0xee,  0xcf,  0xa4,  0x4a,  0xa2, 
0x26,  0xc5,  0x74,  0x84,  0xfb,  0x7f,  0x10,  0xbc,  0x98,  0x11,  0x43,  0x26,  0xf8,  0xff,  0x4f,  0x66, 
0x10,  0x99,  0x75,  0xf7,  0xe0,  0x05,  0x20,  0x00,  0x04,  0xff,  0xf0,  0x05,  0x11,  0x40,  0xf8,  0x8f, 
0xa1,  0xe1,  0x3f,  0x82,  0xc6,  0xf7,  0xe8,  0x1b,  0xc2,  0xb7,  0x17,  0x34,  0x70,  0x29,  0x20,  0x84, 
0x07,  0x4f,  0x70,  0x10,  0x01,  0x42,  0x00,  0x96,  0xc1,  0x27,  0x42,  0xd0,  0x00,  0x06,  0xc0,  0xc1, 
0xbb,  0x0d,  0xdf,  0xcc,  0xc0,  0xb9,  0x73,  0xe8,  0xad,  0x84,  0xbb,  0x67,  0x97,  0x1f,  0x8a,  0x47, 
0x04,  0x2f,  0x5e,  0xf9,  0x23,  0x03,  0xc4,  0xf0,  0x1a,  0x04,  0xd1,  0x59,  0x09,  0x8f,  0x41,  0xe1, 

0x3e,  0xfe,  0x40,  0xe8,  0x00,  0xcd,  0xbf,  0x5a,  0x3b,  0x64,  0x00,  0xd0,  0x61,  0x84,  0x1f,  0x11, 
0xde,  0x3c,  0x7a,  0x8b,  0x7e,  0xee,  0x03,  0xc0,  0x84,  0xf0,  0x10,  0x00,  0xc2,  0x45,  0x90,  0x3a, 
0x5f,  0x21,  0xc2,  0x9d,  0x33,  0x07,  0xe9,  0x21,  0x74,  0xde,  0x1f,  0x7a,  0xea,  0xe8,  0x51,  0xa0, 
0x46,  0x81,  0x9e,  0x3b,  0x74,  0xd7,  0x47,  0x1d,  0x35,  0x05,  0xf4,  0xc8,  0x11,  0x24,  0x17,  0x22, 
0x9c,  0xd1,  0x53,  0x1f,  0x11,  0xe9,  0xab,  0x53,  0xd0,  0x36,  0x00,  0x10,  0x20,  0x10,  0x30,  0x20, 
0xa8,  0x0b,  0xde,  0xd1,  0x00,  0x9c,  0x03,  0x07,  0x04,  0x09,  0x38,  0x58,  0x05,  0xf4,  0xe8,  0xd3, 
0x4f,  0x1a,  0xf4,  0xd1,  0x11,  0x20,  0xe7,  0xc0,  0x21,  0x01,  0x82,  0xc1,  0x23,  0x70,  0x04,  0x3f, 
0x72,  0xc1,  0x21,  0x10,  0xc1,  0x43,  0x1f,  0x3e,  0xe5,  0x93,  0x43,  0x48,  0xce,  0x9d,  0x3d,  0x07, 
0xf6,  0xec,  0x85,  0x0f,  0x78,  0xe4,  0xc3,  0xa7,  0x7b,  0x79,  0x14,  0xe9,  0xc5,  0x0b,  0x0b,  0x16, 
0x32,  0x04,  0x81,  0xf8,  0x51,  0x00,  0x43,  0x40,  0x51,  0x48,  0x1e,  0x25,  0x20,  0x79,  0x04,  0x82, 
0x8f,  0x9c,  0x23,  0xc8,  0x21,  0x40,  0x47,  0xdf,  0x5d,  0x09,  0x80,  0x16,  0x9e,  0x82,  0x17,  0x3a, 
0x88,  0x59,  0xc2,  0x9d,  0xc2,  0x68,  0x41,  0x5e,  0x7c,  0x05,  0x76,  0xef,  0xc6,  0x75,  0x3d,  0x70, 
0xa7,  0x40,  0x0d,  0x7d,  0xf9,  0xf2,  0x63,  0xf0,  0x49,  0x5e,  0x1f,  0x6e,  0xda,  0x4f,  0x00,  0xff, 
0x7b,  0x01,  0x20,  0xc8,  0x7f,  0x2c,  0x77,  0x88,  0x42,  0x64,  0x40,  0x09,  0x1a,  0x5f,  0x59,  0xa9, 
0x28,  0xaa,  0x44,  0x03,  0x00,  0x55,  0x71,  0x8a,  0xc2,  0x44,  0xf4,  0x52,  0x25,  0x94,  0x14,  0x52, 
0x24,  0x01,  0x00,  0x29,  0x51,  0x72,  0x54,  0x55,  0x45,  0x44,  0xaa,  0xa4,  0x48,  0x21,  0x44,  0x80, 

0x00,  0x0a,  0x14,  0x08,  0x08,  0x08,  0x92,  0x0a,  0xde,  0x44,  0x91,  0x96,  0x07,  0x74,  0x48,  0xa0, 
0xc0,  0x43,  0x87,  0x20,  0x66,  0xd0,  0x4c,  0x1a,  0x54,  0x09,  0x45,  0x83,  0xe0,  0x19,  0xb0,  0x88, 
0x24,  0x82,  0xe0,  0x49,  0x89,  0x08,  0x91,  0x20,  0x11,  0xa0,  0x88,  0x10,  0xa4,  0x14,  0x3c,  0x5d, 
0x52,  0x09,  0x01,  0xe4,  0xc8,  0x06,  0x88,  0x80,  0x40,  0x84,  0xa2,  0x12,  0xa7,  0xfe,  0xfc,  0x85, 
0x00,  0xaa,  0x54,  0xa9,  0x10,  0xa1,  0x4b,  0x36,  0x60,  0x50,  0x71,  0x1a,  0x1c,  0xae,  0x66,  0x71, 
0xd8,  0x0e,  0x01,  0xba,  0x74,  0xdc,  0x1c,  0x71,  0x4e,  0x94,  0x52,  0xa5,  0x47,  0x4f,  0xa9,  0x23, 
0x85,  0x42,  0x3e,  0xb6,  0x3b,  0x21,  0x0a,  0x9d,  0xaa,  0x12,  0xa7,  0xce,  0x91,  0x44,  0x19,  0x24, 
0xc4,  0x4d,  0xaf,  0xe0,  0x91,  0x00,  0x54,  0xb9,  0x69,  0x24,  0x2f,  0xb8,  0x79,  0xff,  0xf3,  0x01, 
0xe4,  0x46,  0x95,  0x99,  0xba,  0x38,  0xd4,  0xdd,  0xc9,  0x94,  0x49,  0x55,  0xa6,  0x99,  0x10,  0xde, 
0x11,  0x83,  0x03,  0x11,  0x99,  0x11,  0xbc,  0x47,  0x44,  0xc0,  0xe0,  0x30,  0xf9,  0x06,  0x00,  0xf7, 
0x78,  0x50,  0x3b,  0x54,  0xd9,  0x4d,  0x28,  0xc1,  0xd1,  0x6e,  0x00,  0xe1,  0x1e,  0x7c,  0x82,  0x83, 
0xbb,  0x60,  0x13,  0x42,  0xe6,  0x07,  0xa2,  0xa8,  0x10,  0x1c,  0x63,  0x01,  0x22,  0x88,  0xeb,  0x87, 
0x53,  0xf8,  0x8c,  0x04,  0xc1,  0x03,  0xf9,  0xf2,  0xe1,  0x1e,  0x3e,  0x83,  0x63,  0xf8,  0x40,  0x98, 
0x40,  0xc3,  0xc7,  0x81,  0xd9,  0xce,  0xd7,  0xc3,  0x27,  0xc7,  0x8d,  0x51,  0x3c,  0x46,  0x81,  0x3b, 
0xe8,  0xf2,  0xef,  0x89,  0x4f,  0x77,  0x22,  0xb6,  0x84,  0x08,  0x25,  0xee,  0x82,  0xeb,  0x43,  0x14, 
0x43,  0xcb,  0x8c,  0x0a,  0x15,  0x2d,  0xdc,  0xbf,  0x19,  0x37,  0x6e,  0x82,  0x87,  0x19,  0x33,  0x5f, 

0xfd,  0x0f,  0x88,  0x37,  0xe3,  0xc3,  0xab,  0x9f,  0xbf,  0xee,  0xdf,  0x5c,  0xff,  0xef,  0xff,  0xfd, 
0xff,  0x23,  0x53,  0x91,  0x4a,  0xb0,  0xff,  0xd7,  0x08,  0x5d,  0xee,  0xa4,  0x4a,  0x94,  0xd2,  0xff, 
0x83,  0x03,  0x76,  0x5d,  0x0e,  0xdd,  0x3a,  0xd4,  0x85,  0x37,  0x34,  0x04,  0x57,  0xbc,  0x78,  0x31, 
0x61,  0xc4,  0x14,  0x08,  0xb0,  0x07,  0x9f,  0xe0,  0xe0,  0x36,  0x68,  0x04,  0xc8,  0x40,  0x11,  0x82, 
0xfb,  0xa7,  0xbe,  0xe0,  0x85,  0x5d,  0x5f,  0xff,  0x43,  0xee,  0x2a,  0x38,  0x25,  0x82,  0x3e,  0xd0, 
0x7f,  0xc3,  0x67,  0x2c,  0x08,  0x1e,  0x90,  0x16,  0x28,  0x42,  0x57,  0x6e,  0x9d,  0x07,  0x08,  0xe7, 
0xae,  0x90,  0x5f,  0x14,  0x99,  0xb3,  0xe1,  0x5b,  0xc8,  0x0b,  0x08,  0x53,  0xa0,  0xc6,  0x1e,  0x05, 
0x11,  0xaa,  0xfa,  0x07,  0xa9,  0x07,  0xbe,  0x12,  0x4c,  0x28,  0x35,  0x23,  0x4a,  0xd4,  0x0b,  0xef, 
0x1f,  0x26,  0x4c,  0x04,  0x8f,  0xfe,  0xdf,  0x23,  0xfc,  0xf9,  0xf2,  0x62,  0x46,  0x3c,  0x7d,  0xf3, 
0x3d,  0xfc,  0x03,  0xfe,  0xff,  0xfe,  0xff,  0xff,  0xfb,  0x17,  0x51,  0x9a,  0x50,  0xfe,  0xff,  0x8d, 
0xd0,  0xed,  0x8e,  0x26,  0x4c,  0x92,  0xff,  0x3f,  0x38,  0x60,  0xd6,  0x0d,  0xcf,  0x1e,  0xbc,  0x40, 
0xf9,  0x7d,  0x82,  0x40,  0x00,  0x40,  0x0c,  0x19,  0x71,  0xa0,  0xac,  0x2f,  0x81,  0x33,  0x68,  0x06, 
0xea,  0xfe,  0x1b,  0x15,  0x00,  0x43,  0x06,  0x1c,  0x1d,  0xfe,  0x1f,  0x77,  0x7c,  0xc1,  0x23,  0x40, 
0xe2,  0xe6,  0xd4,  0xff,  0x74,  0x87,  0x03,  0xc8,  0x21,  0x01,  0x77,  0x18,  0xe8,  0x3f,  0xd0,  0xf5, 
0xe1,  0x0b,  0x40,  0xfa,  0x38,  0x5d,  0x14,  0xf9,  0xd0,  0xdd,  0x69,  0xc5,  0x8a,  0x13,  0xab,  0x56, 
0x77,  0x1c,  0x7d,  0xde,  0x14,  0xf9,  0xff,  0x43,  0xc9,  0xff,  0x68,  0x00,  0xc1,  0xf5,  0x7e,  0x8a, 

0xa0,  0xda,  0xff,  0xfb,  0xb7,  0x38,  0x71,  0xef,  0xe3,  0xff,  0xbf,  0x4f,  0x75,  0x24,  0x82,  0xf9, 
0xff,  0x76,  0xf3,  0xff,  0xff,  0xff,  0xff,  0xff,  0xdf,  0xc1,  0x81,  0x48,  0xff,  0xef,  0x5f,  0x11, 
0x60,  0x38,  0xf4,  0x7f,  0xdd,  0x01,  0x60,  0x18,  0x06,  0xaa,  0xe0,  0x16,  0x22,  0x99,  0x31,  0x0b, 
0xfe,  0xa3,  0x23,  0x24,  0x07,  0xa1,  0xfe,  0x1b,  0x51,  0xfe,  0x5f,  0xeb,  0x88,  0x29,  0xc8,  0xfb, 
0x7f,  0xf0,  0x41,  0xf8,  0x7f,  0x7b,  0x47,  0x00,  0x09,  0xcf,  0xd5,  0xc3,  0x27,  0x47,  0x77,  0x54, 
0xcf,  0x43,  0x40,  0x18,  0x1d,  0xf2,  0x6b,  0x8a,  0xcf,  0xee,  0x41,  0xea,  0x7f,  0x28,  0x71,  0x17, 
0x5c,  0xeb,  0xa7,  0x18,  0x5a,  0x66,  0x54,  0xa8,  0xb8,  0xff,  0xfd,  0xc3,  0x8d,  0x9b,  0xe0,  0xd1, 
0xff,  0x7b,  0x84,  0x7b,  0xf7,  0xe2,  0xcd,  0xf8,  0xf0,  0xea,  0xa7,  0x87,  0x1f,  0x0c,  0x56,  0x70, 
0x58,  0x7d,  0xf7,  0x11,  0xe1,  0xcf,  0x25,  0x4c,  0xa0,  0x30,  0xdd,  0xf8,  0x1b,  0xe1,  0xfe,  0x5c, 
0x01,  0x01,  0x0a,  0xd0,  0x65,  0xf0,  0x77,  0xe7,  0xda,  0x1d,  0x53,  0x80,  0x4c,  0xfa,  0xbf,  0x3b, 
0xd6,  0xa0,  0x5d,  0x3b,  0x64,  0xeb,  0x30,  0x50,  0xb0,  0x2e,  0xdf,  0xfe,  0x5c,  0x83,  0x0e,  0x12, 
0x80,  0x00,  0x02,  0x0a,  0x1e,  0xa0,  0x83,  0x5f,  0x88,  0x84,  0x0d,  0x0c,  0x58,  0xe0,  0x4c,  0x49, 
0xfe,  0x1c,  0x02,  0x72,  0x17,  0x1c,  0x02,  0xa4,  0x3b,  0x40,  0x0e,  0x83,  0xb7,  0x23,  0xe0,  0xae, 
0x63,  0x42,  0x70,  0x08,  0x04,  0xc0,  0x1d,  0x05,  0x6f,  0xe7,  0xe1,  0x03,  0x36,  0x6c,  0xd4,  0xc1, 
0xc1,  0x35,  0x24,  0xe7,  0x05,  0xd9,  0x1d,  0x40,  0xd7,  0x69,  0x33,  0x41,  0xb8,  0xfe,  0x1d,  0xd7, 
0x98,  0xe5,  0x6c,  0x00,  0xc7,  0x0e,  0x5c,  0x00,  0x70,  0xc7,  0xfc,  0xc6,  0xb2,  0x74,  0xe7,  0x02, 

0x96,  0x2b,  0x17,  0xa0,  0xba,  0xff,  0x4e,  0x80,  0xe1,  0xd4,  0x8f,  0x2b,  0x58,  0xd7,  0xff,  0x7f, 
0xe8,  0x70,  0x11,  0x3c,  0xc0,  0xf4,  0xff,  0x92,  0xe0,  0xcb,  0x8b,  0x1f,  0xf7,  0xf0,  0xcd,  0xff, 
0xf0,  0x8b,  0xc1,  0x0c,  0x22,  0xb3,  0xf8,  0x9e,  0x93,  0x01,  0x00,  0x8c,  0xef,  0xe1,  0x8b,  0x01, 
0x00,  0x06,  0xe9,  0xfd,  0x45,  0x1c,  0x0f,  0x60,  0x0c,  0x80,  0xf5,  0xff,  0x78,  0x00,  0xe0,  0x02, 
0x40,  0x0b,  0x94,  0x09,  0xd5,  0x1d,  0x80,  0x20,  0x11,  0x10,  0x02,  0x56,  0xf0,  0x0b,  0x91,  0x10, 
0x83,  0x65,  0xf0,  0x0f,  0x11,  0xc1,  0x21,  0x40,  0x04,  0xff,  0xf8,  0x18,  0x9c,  0xc2,  0x7f,  0x5e, 
0x08,  0x5a,  0xbf,  0x00,  0x42,  0xf0,  0x8f,  0x97,  0x09,  0x22,  0xf8,  0xb1,  0xcf,  0x1a,  0xe9,  0x86, 
0x81,  0xb7,  0x9a,  0xc2,  0x3e,  0x4d,  0x65,  0xca,  0xe0,  0xda,  0x1c,  0xa3,  0x46,  0xc0,  0xfe,  0xff, 
0xe1,  0x4b,  0x77,  0xff,  0xcf,  0x51,  0xdd,  0xcc,  0x3f, 
};
static PROGMEM prog_uchar sprite_player_sprpal[] = {

0xbd,  0x77,  0x93,  0x62,  0x0d,  0x5a,  0xd1,  0x25,  0x84,  0x51,  0x02,  0x35,  0x49,  0x19,  0x84,  0x34, 
0xc2,  0x2c,  0xc3,  0x24,  0x62,  0x18,  0xa5,  0x08,  0x21,  0x08,  0x00,  0x50,  0x00,  0x00,  0x00,  0x80, 
};



static PROGMEM prog_uchar common_text_chr[] = {

  0xc9,  0x01,  0xde,  0x91,  0x53,  0x15,  0xe0,  0xc8,  0x52,  0x25,  0x00,  0x80,  0xbf,  0x7f,  0xaa,  0x01, 
  0x1c,  0x00,  0x00,  0x55,  0xaa,  0xfc,  0x07,  0x0f,  0xd2,  0x01,  0x0e,  0x00,  0x68,  0x55,  0xaa,  0x83, 
  0x47,  0xc8,  0x90,  0x4a,  0x55,  0x02,  0x00,  0x49,  0x02,  0x24,  0x01,  0x08,  0x14,  0xfa,  0xa3,  0xa5, 
  0x2a,  0x95,  0x54,  0xe9,  0x02,  0x00,  0x1b,  0x60,  0xfc,  0xfb,  0x8d,  0x17,  0xc9,  0x3f,  0xf5,  0xc6, 
  0xff,  0xc4,  0x97,  0x29,  0xc9,  0xfb,  0xcf,  0xf5,  0xe1,  0x23,  0x73,  0xa6,  0xaa,  0x00,  0x47,  0x95, 
  0x3a,  0x00,  0xc0,  0xfe,  0x3d,  0xab,  0x92,  0x1c,  0xe0,  0xb3,  0x77,  0x80,  0xc9,  0xfe,  0xd9,  0x3f, 
  0x5e,  0x10,  0xa5,  0x42,  0x94,  0x00,  0x41,  0xa0,  0x14,  0xa8,  0x52,  0x81,  0x4a,  0x15,  0x08,  0x05, 
  0xa2,  0x01,  0x80,  0x42,  0x6d,  0x20,  0x08,  0x02,  0x28,  0x22,  0x28,  0x08,  0x20,  0x90,  0x02,  0x40, 
  0x24,  0x68,  0x00,  0x48,  0x1f,  0x40,  0xa9,  0x10,  0xa4,  0x00,  0x91,  0x22,  0x05,  0x82,  0x54,  0x80, 
  0xe6,  0x85,  0x48,  0x10,  0x28,  0x00,  0x44,  0x4a,  0xa2,  0x54,  0x83,  0x03,  0x05,  0xa0,  0x14,  0x29, 
  0xe6,  0xab,  0x00,  0x1f,  0x94,  0x13,  0x47,  0x80,  0x2b,  0x13,  0x01,  0x2b,  0x6d,  0x04,  0x88,  0x91, 
  0x3f,  0x0e,  0x83,  0x17,  0x00,  0x80,  0x01,  0x27,  0x4c,  0xe5,  0x0e,  0x0a,  0x41,  0x82,  0x6a,  0xd2, 
  0x88,  0x02,  0x04,  0xb2,  0x40,  0xf4,  0x8c,  0x91,  0x04,  0x21,  0x02,  0x05,  0x12,  0x2a,  0x02,  0x53, 
  0x9c,  0xa4,  0x00,  0x35,  0x41,  0x42,  0xad,  0x08,  0x40,  0x82,  0x01,  0x40,  0x02,  0x10,  0x52,  0x56, 
  0x8c,  0xdc,  0xe4,  0xdb,  0x32,  0x56,  0x06,  0x8f,  0x00,  0xd5,  0x20,  0xa3,  0x57,  0xe0,  0x09,  0x90, 
  0x91,  0x2f,  0x09,  0x54,  0x89,  0x4a,  0x51,  0x2d,  0x52,  0xc0,  0xd9,  0x49,  0x50,  0x04,  0x00,  0x56, 

  0x98,  0xc4,  0x1e,  0x7a,  0xd3,  0x5c,  0xf8,  0xc8,  0xe0,  0x2f,  0x3c,  0xc6,  0x66,  0x83,  0xc4,  0x91, 
  0xb3,  0x03,  0x63,  0x70,  0x4a,  0x9d,  0x04,  0xcb,  0x44,  0xd9,  0x08,  0x8c,  0x8d,  0xb2,  0x79,  0x55, 
  0x8b,  0x81,  0x1f,  0x7e,  0x62,  0x5c,  0xaa,  0x0a,  0x3e,  0x4b,  0x33,  0xfa,  0xed,  0x8d,  0x09,  0xd9, 
  0x0e,  0x86,  0x47,  0xad,  0x8e,  0x98,  0xd1,  0x61,  0x48,  0xc4,  0xc8,  0xf0,  0x9f,  0x83,  0xc6,  0x46, 
  0x74,  0x8c,  0xde,  0x09,  0x33,  0xf9,  0xa6,  0xff,  0x28,  0x1d,  0xfe,  0x82,  0x6c,  0xa4,  0x4a,  0x13, 
  0xcb,  0xbb,  0xcb,  0x05,  0xfe,  0xe0,  0x3f,  0x61,  0x9f,  0xc2,  0xc6,  0xf8,  0x5f,  0xe3,  0xb7,  0xdf, 
  0x0c,  0xf8,  0x7c,  0x19,  0xb6,  0x22,  0x56,  0xb2,  0x6a,  0xfe,  0xef,  0xb7,  0x7f,  0x11,  0x81,  0x18, 
  0x20,  0x1f,  0x4d,  0xfe,  0x6d,  0x94,  0x01,  0xb8,  0x79,  0x06,  0x9f,  0x40,  0x3b,  0x3e,  0x01,  0x36, 
  0xaf,  0x86,  0x74,  0x23,  0x33,  0xd7,  0xfb,  0x8a,  0x26,  0x40,  0x83,  0x46,  0xff,  0xe9,  0x9e,  0xd9, 
  0x32,  0x50,  0x16,  0xee,  0xe0,  0x5f,  0x81,  0xb7,  0x77,  0x3b,  0x48,  0xdf,  0x9d,  0x72,  0x31,  0x65, 
  0xff,  0xec,  0x75,  0x3c,  0xf6,  0xde,  0x91,  0xbc,  0x40,  0xd9,  0x64,  0xf9,  0x53,  0x80,  0x42,  0x81, 
  0x02,  0x45,  0x02,  0x54,  0x01,  0x04,  0x8c,  0xc0,  0x11,  0x34,  0x00,  0x00,  0x08,  0xef,  0xd9,  0x37, 
  0x7c,  0x50,  0xa1,  0x32,  0x13,  0x28,  0x46,  0x8a,  0x00,  0x1d,  0x3e,  0x82,  0x27,  0x14,  0xaa,  0x50, 
  0x28,  0x52,  0xa1,  0x10,  0x20,  0x82,  0x4f,  0xb5,  0x3b,  0x7e,  0xed,  0xaf,  0xfc,  0x36,  0x8f,  0x67, 
  0x18,  0x90,  0x81,  0x34,  0x8f,  0xf6,  0x15,  0xfe,  0x22,  0xf7,  0xfc,  0xc9,  0x0f,  0x45,  0xb2,  0x46, 
  0x3e,  0x9f,  0xea,  0x7f,  0xb9,  0xd3,  0x7d,  0xfa,  0x0d,  0xfa,  0xcf,  0x62,  0x67,  0x97,  0x9e,  0xf2, 

  0xf1,  0x1a,  0x02,  0x40,  0xf1,  0x81,  0x02,  0x25,  0x2c,  0x00,  0xdc,  0x0c,  0x55,  0xa0,  0x4d,  0x00, 
  0x0d,  0xfe,  0xa9,  0x21,  0x40,  0x57,  0x8f,  0xff,  0xd0,  0x10,  0xc2,  0x25,  0x80,  0xae,  0x40,  0x21, 
  0x68,  0x45,  0xcf,  0xfd,  0x11,  0xe0,  0xaf,  0x57,  0x98,  0x8c,  0x0d,  0x51,  0x32,  0x88,  0xc4,  0xcf, 
  0xb7,  0x11,  0xe0,  0xe6,  0xd7,  0xa2,  0x5a,  0x5d,  0x01,  0x3e,  0xe0,  0x07,  0x87,  0x38,  0x10,  0xbe, 
  0x6a,  0xe5,  0xe6,  0x0a,  0xf7,  0x1d,  0x6b,  0x18,  0xe4,  0x82,  0xf3,  0xbb,  0xba,  0x66,  0xee,  0xff, 
  0x0a,  0x3f,  0xd3,  0xe6,  0xfc,  0x45,  0xad,  0xe7,  0x17,  0x7e,  0x5f,  0x54,  0xf9,  0xa6,  0x52,  0x3d, 
  0xdb,  0x61,  0xcd,  0x8d,  0xbf,  0xff,  0x6e,  0x54,  0xa6,  0xff,  0xff,  0x3b,  0xb1,  0x96,  0x7d,  0xe9, 
  0x0a,  0x38,  0x2d,  0xf6,  0x5c,  0x7c,  0xef,  0x9b,  0x10,  0xa4,  0x5a,  0xf7,  0xbe,  0x6f,  0xfc,  0x9d, 
  0x01,  0xe0,  0x08,  0x04,  0x72,  0x03,  0x2b,  0x63,  0x1b,  0x4e,  0xff,  0xc1,  0xf7,  0x61,  0x9d,  0xbf, 
  0xf0,  0xff,  0xb1,  0x9a,  0x61,  0xf9,  0x2f,  0xdf,  0x21,  0x24,  0x7e,  0x07,  0xb3,  0xfe,  0x3b,  0xb1, 
  0x86,  0x57,  0x9b,  0x6a,  0x7f,  0x5d,  0x23,  0x82,  0xfc,  0xff,  0xe1,  0x9b,  0xed,  0xfe,  0x57,  0xf6, 
  0x2a,  0x53,  0xe5,  0xe3,  0x16,  0x54,  0x84,  0xe0,  0x17,  0x02,  0x28,  0x34,  0xcf,  0xea,  0x17,  0xfd, 
  0xef,  0x46,  0xfd,  0x29,  0x12,  0x41,  0x3b,  0x70,  0xc6,  0xc3,  0x1b,  0x95,  0x35,  0x6f,  0x6f,  0xbf, 
  0x1f,  0x30,  0x85,  0xea,  0x45,  0x47,  0x9a,  0x76,  0x9d,  0x35,  0xde,  0x3f,  0x55,  0xaa, 
};
static PROGMEM prog_uchar common_text_pal[] = {

  0xc9,  0x01,  0x78,  0xe3,  0x64,  0xee,  0x9f,  0x3f,  0x0c,  0x00,  0x10,  0x08,  0x05,  0xaa,  0xa0,  0x11, 
  0xf8,  0x09,  0x01,  0x60,  0x21,  0x85,  0x52,  0xc8,  0x08,  0x9c,  0x4c,  0x02,  0x4f,  0xe4,  0x8f,  0xbc, 
  0xb1,  0x2f,  0xf0,  0x27,  0x5e,  0x08,  0x00,  0x62,  0x4f,  0xe0,  0x4b,  0x5e,  0x01,  0x28,  0x50,  0x04, 
  0x89,  0xa0,  0x11,  0x14,  0x82,  0x5f,  0xe8,  0x0f,  0xd7,  0xa1,  0x3f,  0xfc,  0x47,  0xfe,  0xe8,  0x1f, 
  0xf8,  0xa3,  0x7f,  0xec,  0x8f,  0xff,  0x89,  0x3f,  0xf9,  0x27,  0xfe,  0xe4,  0x9f,  0xfa,  0x73,  0x7f, 
  0xfe,  0x2f,  0xfc,  0x95,  0x3f,  0xf4,  0x47,  0xfe,  0xe8,  0x1f,  0xfb,  0x9b,  0x7f,  0xeb,  0x6f,  0xff, 
  0xdd,  0x3f,  0xfd,  0x67,  0xff,  0xdc,  0x9f,  0xff,  0x47,  0xff,  0xf8,  0x9f,  0xfc,  0xb3,  0xbf,  0xf2, 
  0xd7,  0xfe,  0xc8,  0xdf,  0xf8,  0xb7,  0xff,  0xe6,  0x0f,  0xfe,  0xa1,  0x3f,  0xff,  0xf7,  0xff,  0xc2, 
  0x3f,  0xfc,  0x43,  0x7f,  0xf8,  0x8f,  0xfc,  0xe9,  0x3f,  0xf5,  0x07,  0xff,  0xdc,  0x9f,  0xfb,  0xb3, 
  0x7f,  0xe6,  0xcf,  0xfe,  0xb9,  0x7f,  0xf8,  0x1f,  0xff,  0xd1,  0x7f,  0xfe,  0x2b,  0x7f,  0xf5,  0xaf, 
  0xfd,  0xf5,  0x7f,  0xf4,  0xbf,  0xfe,  0xf5,  0xff,  0xf9,  0xbb,  0x7f,  0xef,  0xef,  0xff,  0x83,  0xff, 
  0xfc,  0x9f,  0xff,  0xca,  0x3f,  0xfd,  0x67,  0xff,  0xfc,  0x5f,  0xfc,  0xcb,  0xff,  0xf5,  0x7f,  0xfe, 
  0xef,  0x03,  0x00, 
};


