/*

 Name      :  Fire
 Notes     :  Flames rising up the screen
 
 The fire effect has been used quite often for oldskool demos. 
 First you create a palette of 256 colors ranging from red to
 yellow (including black). For every frame, calculate each row 
 of pixels based on the two rows below it: The value of each pixel,
 becomes the sum of the 3 pixels below it (one directly below, one 
 to the left, and one to the right), and one pixel directly two 
 rows below it. Then divide the sum so that the fire dies out 
 as it rises.
 
 references:
 http://www.student.kuleuven.be/~m0216922/CG/fire.html 
 
 */

class Fire
{
public:
  Fire(){

    // clear screen of character data  
    GD.fill(RAM_PIC, 0, 0x0FFF); // 255 = color index
    GD.fill(RAM_CHR, 0, 4096); // second number is color 0-3  


    // generate flame color palette in RGB. need 256 bytes available memory
    for(byte i=0; i<86; i++)
    {
      GD.setpal(i*4, RGB(i*3,0,0));          // Black to red
      GD.setpal((i+85)*4, RGB(255,i*3,0));   // Red to yellow
      GD.setpal((i+170)*4, RGB(255,255,i*3));   // yellow to white
    } 

    //memset(fire_buffer, 0x00, sizeof(fire_buffer)); // erase 
  }

  ~Fire(){
  }
#define widthLeft RENDERWIDTH-1
#define widthRight RENDERWIDTH+1
  //#define bufferY (RENDERHEIGHT*64)+RAM_PIC

  void draw(int timeDisplacement){
    do{    
      //    for(byte x = 0; x < w-1; x++){
      //      fire_buffer[x+fire_length] = (byte)random(255);
      //      fire_buffer[x+fire_length] = 0;
      //    }
      render();
      fb();
      delay(55);
      screenshot();
    }
    while(--timeDisplacement);
  }


  void render(){

    // Do the fire calculations for every pixel, from top to bottom
    int currentPixelIndex = 1; // start from center
    for (int y = RAM_PIC; y < bufferY;y+=64) { 
      for(byte x = 0; x < RENDERWIDTH; ) {
        // Add pixel values around current pixel
        // Output everything to screen using our palette colors      

        // change to add 3 instead of 4 to speed this up for firecubefs
        fire_buffer[currentPixelIndex] = ((fire_buffer[currentPixelIndex]
          + fire_buffer[currentPixelIndex+widthLeft]
          //          + fire_buffer[currentPixelIndex+w]
        + fire_buffer[currentPixelIndex +widthRight])  >>2) ;          

        //            if (fire_buffer[currentPixelIndex] > 254  ) fire_buffer[currentPixelIndex] = 0;                  

        //pixel_buffer[x++] =  fire_buffer[currentPixelIndex++];
        // pixel_buffer[x++] =  fire_buffer[currentPixelIndex++];

        if (currentPixelIndex == RENDERWIDTH*RENDERHEIGHT) fire_buffer[currentPixelIndex] = 0;                  

        x++;
        currentPixelIndex++;        

      }
    }
  }

private:

};





