/*

 Name      :  Lens
 Notes     :  Flames rising up the screen
 
 The fire effect has been used quite often for oldskool demos. 
 First you create a palette of 256 colors ranging from red to
 yellow (including black). For every frame, calculate each row 
 of pixels based on the two rows below it: The value of each pixel,
 becomes the sum of the 3 pixels below it (one directly below, one 
 to the left, and one to the right), and one pixel directly two 
 rows below it. Then divide the sum so that the fire dies out 
 as it rises.
 
 references:
 http://www.student.kuleuven.be/~m0216922/CG/fire.html 
 
 */

void lens(){

  byte w = 50;
  byte h= 37;

  byte timeDisplacement=950;  // number of frames to run
//  int bufferY = (h*64)+RAM_PIC;
  byte pixel_buffer[w];

  int lensD = 128;
  int xx = 0;
  int yy = 0; 
  int dx = 1;
  int dy = 1;

  int ballSize = 64;

  int lensPixels = lensD*lensD;


  for (int i = 0; i < lensPixels; i++)  {
    //lensImage[i] = lensEffect[(ball_x + (lensArray[i] % lensD))+(ball_y + (lensArray[i] >> 7))*w]; 
    //lensImage[i] = lensEffect[(ball_x + lensArrayMod[i])+(ball_y + lensArrayDiv[i])*w]; 
  }


  /*
  do{    
   
   // Do the fire calculations for every pixel, from top to bottom
   int currentPixelIndex = 1; // start from center
   for (int y = RAM_PIC; y < bufferY;y+=64) { 
   for(byte x = 0; x < w; ) {
   // change to add 3 instead of 4 to speed this up for firecubefs
   pixel_buffer[x++] =      fire_buffer[currentPixelIndex] = (fire_buffer[currentPixelIndex]
   + fire_buffer[currentPixelIndex+widthLeft]
   + fire_buffer[currentPixelIndex+w]
   + fire_buffer[currentPixelIndex++ +widthRight])  >>2;          
   }
   GD.copy2(y,pixel_buffer,w);
   }
   }
   while(--timeDisplacement);
   */

}

// Lens algorithm (transformation array)
void calculate_tfm(int lensD, int magFactor)
{
  int lensArray[16*16];     

  int counter=0;
  int before = 0; //millis();

  int a, b;
  int r = lensD /2;
  int rSq=r*r;
  int s = (rSq - magFactor*magFactor);

  int x2;
  int y2;

  int temp;
  int temp2;

  // calculate the first quadrant (90 degrees) of the lens deformation, then extrapolate the other three quadrants
  for (int y = -r; y <= 0; y++) {
    y2=y*y;
    temp = ( y + r )*lensD;
    temp2 =(-y + r )*lensD;
    for (int x = -r ;x <= 0; x++) {
      x2=x*x;

      counter++;
      if(x2 + y2 >= s) {
        a = x;
        b = y;
      }
      else {
        float z = (float)sqrt(rSq - x2 - y2) ;
        a = (int)floor(x * magFactor / z);
        b = (int)floor(y * magFactor / z);
      }
      //  mirror quadrant of lens to make a complete circle
      lensArray[ temp2 - (-x + r)] =        ((-b + r) * lensD - (-a + r));          // bottom left
      lensArray[(temp2 + (-x + r))-lensD] = ((-b + r) * lensD + (-a + r))-lensD;    // bottom right
      lensArray[ temp + ( x + r)] =          ( b + r) * lensD + ( a + r);           // top left
      lensArray[(temp - ( x + r))+lensD] =   ( b + r) * lensD - ( a + r)+lensD;     // top right      
    }
  }
}


