/*

 Name      :  Sinescroller
 Notes     :  sinewave text dypp scroller
 
 references:
 
 */

#include "fontShort.h"

const PROGMEM char scrollText[] = "   AT PARTY 2013 WILL HELD AT MIT UNIVERSITY IN BOSTON USA    ";
//const PROGMEM char scrollText[] = "   3LN Hornet CMUCC Fairlight Paradise QBR TPOLM Razor 1911    ";

#define sinelength 512 

class Sinescroller
{
public:
  Sinescroller(){
    initFont();
    //initScrollText();
    //initRasters();
    initSine();  
    
    scrollOffset=0;
    scrollPos=0;
    sinePos=0;    
  }


  ~Sinescroller(){
  }

  void draw(int frameCount){
    do
    {
      render();
      fb();
      screenshot();
    }
    while(--frameCount);   
  };


  //! Byte swap unsigned short
  uint16_t swap_uint16( uint16_t val ) 
  {
    return (val << 8) | (val >> 8 );
  }

  //! Byte swap short
  int16_t swap_int16( int16_t val ) 
  {
    return (val << 8) | ((val >> 8) & 0xFF);
  }
  


  void render() {
    // obtain current scroll offset/text position and sine position,
    // then advance all of them.
    // scroll offset runs from 0 to 15. when it reaches 15, the
    // scroll position (the scrolltext character to be drawn) advances
    // and the scroll offset goes back to 0.

    int sco = scrollOffset;
    int scp = scrollPos;
    int sp = sinePos;
    int ypos = 0;

//  int sco = scrollOffset, scp = scrollPos, sp = sinePos, y, ypos;

    if (++scrollOffset >= 16) {
      scrollOffset = 0;
      if (++scrollPos >= sizeof(scrollText)) scrollPos = 0;
    }

    sinePos += 4; 	// how fast text goes up and down
    if (sinePos >= sinelength) sinePos -= sinelength;

    // draw a series of 16-pixel high vertical lines


    //  for (x = 0; x < RENDERWIDTH*RENDERHEIGHT; x++) {
    //   fire_buffer[x]=color(0,0,0);
    //  }


    for (int x = 2; x < RENDERWIDTH; x++) {
      ypos = ssine[sp++]; 
      if (sp >= sinelength) sp = 0;


      //    int data = font[(fontLookup[pgm_read_byte_near(&scrollText[scp])] << 4) + sco]; // get scrolltext from flash memory 

/*

      int readIndex = ((fontLookup[pgm_read_byte_near(&scrollText[scp])] << 4) + sco) << 1;
      unsigned char TempA = pgm_read_byte_near(&FONTSHORT[readIndex]); 
      unsigned char TempB = pgm_read_byte_near(&FONTSHORT[readIndex+1]); 
      int data = TempB  +  (TempA << 8) ;
  */


      int data = font[(fontLookup[pgm_read_byte_near(&scrollText[scp])] << 4) + sco]; // get scrolltext from flash memory 


      // todo: convert font to 8x8 and read word
      //      int data = pgm_read_word_near(&FONTSHORT[readIndex]);
      //      font[i] = arr;


      //int swap = pgm_read_word_near(&FONTSHORT[   (fontLookup[pgm_read_byte_near(&scrollText[scp])] << 4) + sco]);
      //int data = (swap<<8) | (swap>>8);

      //unsigned short wBigE = swap;
      //int data = ((wBigE & 0xFF) << 8) | (wBigE >> 8);
      //int data = swap_uint16(swap);


      //    int data = (fontLookup[pgm_read_byte_near(&scrollText[scp])] << 4) + sco]; // get scrolltext from flash memory       
      //    char sT=pgm_read_byte_near(&scrollText[scp]);
      //    int fL = (fontLookup[sT] << 4) + sco;
      //    unsigned int data = font[fL]; // get scrolltext from flash memory 
      //    int data = pgm_read_word_near(&FONTSHORT[fL]);  //convert to little endian

      if (++sco >= 16) {
        sco=0; 
        if (++scp >= sizeof(scrollText)) scp=0;
      }


      for (int y = 0; y < 16; y++) {
        if ((data & (1<<y)) != 0) {
          //        fire_buffer[(y+ypos)*RENDERWIDTH + x] = rasters[y+ypos];



          //        if ( (x+(y+ypos)*RENDERWIDTH) < sizeof(fire_buffer) )
          fire_buffer[x+(y+ypos)*RENDERWIDTH ] = 220;//rasters[y+ypos];        



          //        DrawChar(x,y+ypos,rasters[y+ypos]);

          // scroll shadow
          //        if ((y+ypos+2 < RENDERHEIGHT) && (x+2 < RENDERWIDTH))
          //        DrawChar(x+2,y+ypos+2,color(180,180,180));
          //	pD[(y+ypos+2)*RENDERWIDTH + x+2] = color(180,180,180);//0x000000;
        }
      }
    }
  }

private:
  unsigned int scrollPos;
  unsigned int scrollOffset;
  unsigned int sinePos;
  char fontLookup[256];
  int ssine[sinelength];
  unsigned short font[46 * 16];
  //  int rasters[240];

  // loads the classic 16x16 font into font[]
  // classic_16x16 has 46 glyphs:
  //  !'(),-.:?0123456789abcdefghijklmnopqrstuvwxyz
  //  http://www.flickr.com/photos/cumbrowski/sets/72157611369269727/
  void initFont(){
    // set up the font lookup table
    // fontLookup[character] = glyph number
    char sc[] = " !'(),-.:?0123456789abcdefghijklmnopqrstuvwxyz";

    int i;
    for (i = 0; i < 256; i++) fontLookup[i] = 0; // space
    for (i = 0; i < 46; i++)
      fontLookup[(char) sc[i]] = (char) i;

    char c;
    for (c = 'A'; c <= 'Z'; c++) // also do A-Z, not just a-z
      fontLookup[c] = (char)((int)(c-'A') + 20);


    int bmpcount=0;
     for (i = 0; i < sizeof(font)/2; i++) {
     
    unsigned char TempA = pgm_read_byte_near(&FONTSHORT[bmpcount++] ); 
    unsigned char TempB = pgm_read_byte_near(&FONTSHORT[bmpcount++] ); 
    short arr = TempB  +  (TempA << 8) ;
    font[i] = arr;
     }


  }

  // creates scrollText[], which is an array of glyph lookups rather
  // than ascii text
  void initScrollText() {
    int i;
    for (i = 0; i < sizeof(scrollText); i++) {
      //  scrollText[i] = fontLookup[scrollText[i]];
    }
  }

  // a simple set of colour fades down the screen
  void initRasters() {
    int cols[] = { 
      0xFF0000, 0xFFFF00, 0x00FF00, 0x00FFFF, 0xFF00FF, 0x00FFFF, 0x0000FF                   };

    int colSize = (sizeof(cols)/2)-1;

    int bar = 0, seg = RENDERHEIGHT / colSize;

    //  int rasters[scrH];
    //    rasters = (int *) malloc(scrH);

    int r_from, g_from, b_from, r_to, g_to, b_to;
    r_from = (cols[0] >> 16) & 0xFF;
    g_from = (cols[0] >>  8) & 0xFF;
    b_from = (cols[0]      ) & 0xFF;

    int x;
    for (x = 1; x <= colSize; x++) {
      r_to = (cols[x] >> 16) & 0xFF;
      g_to = (cols[x] >>  8) & 0xFF;
      b_to = (cols[x]      ) & 0xFF;
      int y;
      for (y = 0; y < seg; y++) {
        int r, g, b;
        r = r_from + ((r_to - r_from) * (y+1)) / seg;
        g = g_from + ((g_to - g_from) * (y+1)) / seg;
        b = b_from + ((b_to - b_from) * (y+1)) / seg;

        //int gradient = 0x000000 | (r << 16) | (g << 8) | b;
        //rasters[bar++] = QBR_CONV_32BITCOL_TO_16BITCOL(gradient);
        //     rasters[bar++] = 0xFF000000 | (r << 16) | (g << 8) | b;
        //rasters[bar++] = color(r,g,b);
        //rasters[bar++] = ((r&0xF8)<<8)|( (g&0xFC)<<3)|((b>>3)&0x1F);
        //rasters[bar++] = RGB888_to_RGB565( 0x000000 | (b << 16) | (r << 8) | g);
      }
      r_from = r_to;
      g_from = g_to;
      b_from = b_to;
    }
  }

  // we use a lookup table for the sine wave rather than calculate it in
  // realtime
  void initSine() {
    //  int sine[1024];
    // 0-1024 will be for us 0 to 4pi (720 degrees)
    // 1024 * x = 4pi, x=4pi/1024 = pi/(1024/4)  = pi/256
    //
    // the amplitude of the wave the screen height - 2, so there's a 1
    // pixel border top and bottom. But we also have to include the size
    // of the font, so the centre line running through the font has an
    // amplitude of screen height - 18 (16 pixel high font). 
    double ampl = ((RENDERHEIGHT) / 4)+1;
    int i;
    for (i = 0; i < sinelength; i++) {
      ssine[i] =    (int)((sin((double)i * 1.00 * (PI/128.0) ) *    ampl) + ampl) + 1;
    }
  }

};



