/*

 Name      :  Fire
 Notes     :  Flames rising up the screen
 
 The fire effect has been used quite often for oldskool demos. 
 First you create a palette of 256 colors ranging from red to
 yellow (including black). For every frame, calculate each row 
 of pixels based on the two rows below it: The value of each pixel,
 becomes the sum of the 3 pixels below it (one directly below, one 
 to the left, and one to the right), and one pixel directly two 
 rows below it. Then divide the sum so that the fire dies out 
 as it rises.
 
 references:
 http://www.student.kuleuven.be/~m0216922/CG/fire.html 
 
 */

void star(){
  // generate flame color palette in RGB. need 256 bytes available memory
  for(byte i=0; i<86; i++)
  {
    GD.setpal(i*4, RGB(i*3,0,0));          // Black to red
    GD.setpal((i+85)*4, RGB(255,i*3,0));   // Red to yellow
    GD.setpal((i+170)*4, RGB(255,255,i*3));   // yellow to white
  } 

//    showPalette();
//    delay(5000);

  byte w = 50;
  byte h= 37;

  byte timeDisplacement=950;  // number of frames to run
  byte fire_buffer[(w+1)*(h)];
  int  fire_length = w*h;
//  byte widthLeft = w-1;
//  byte widthRight = w+1;
//  int bufferY = (h*64)+RAM_PIC;
  byte pixel_buffer[w];
 
  

  do{    
    for(byte x = 0; x < w; x++){
      fire_buffer[x+fire_length] = (byte)random(255);
    }

    // Do the fire calculations for every pixel, from top to bottom
    int currentPixelIndex = 1; // start from center
    for (int y = RAM_PIC; y < bufferY;y+=64) { 
      for(byte x = 0; x < w; ) {
        // Add pixel values around current pixel
        // Output everything to screen using our palette colors      
        

/*
        GD.wr(x++ +y,  fire_buffer[currentPixelIndex] = (fire_buffer[currentPixelIndex]
          + fire_buffer[currentPixelIndex+widthLeft]
          + fire_buffer[currentPixelIndex+w]
          + fire_buffer[currentPixelIndex++ +widthRight])  >>2
          );
          */
          
          // change to add 3 instead of 4 to speed this up for firecubefs
        pixel_buffer[x++] =      fire_buffer[currentPixelIndex] = (fire_buffer[currentPixelIndex]
          + fire_buffer[currentPixelIndex+widthLeft]
          + fire_buffer[currentPixelIndex+w]
          + fire_buffer[currentPixelIndex++ +widthRight])  >>2;          
          

      }
            GD.copy2(y,pixel_buffer,w);
    }
  }
  while(--timeDisplacement);





}


