/* tile stuff */
#include "aliens.h"
#include "sprite_header.h"
#include "map_battle.h"
#include "map_outside.h"
#include "map_mainhall.h"



byte player_dir = PLAYER_DOWN_1;         // direction link is facing
byte player_foot = 0;           // which walking sprite to use
byte player_foot_count = 0;     // keep track of how many pixels since last walkiing switch
byte player_anim = PLAYER_DOWN_1;           // what sprite animation of link to display
int player_x = 200;           // x pixel location of link
int player_y = 200;           // y pixel location of link

byte sayCounter=0;
int yscroll=0;
int screenLine;
int mapPos=0;
volatile int mapID=0;



static void draw_sprite(int x, int y, uint8_t anim, uint8_t rot, uint8_t jk, int spriteNum) {
  switch (anim) {

    /* MAIN PLAYER */
  case 2: // player up 1
    GD.sprite(spriteNum,x, y, 11, 4, rot, jk);
    break;
  case 3: // player up 2
    GD.sprite(spriteNum,x, y, 10, 6, rot, jk);
    break;
  case 4:  // player left 1
    GD.sprite(spriteNum,x, y, 3, 4, 2, jk);    
    break;
  case 5: // player left 2 
    GD.sprite(spriteNum,x, y, 3, 6, 2, jk);    
    break;
  case 6: // player right 1
    GD.sprite(spriteNum,x, y, 3, 4, rot, jk);
    break;
  case 7: // right2
    GD.sprite(spriteNum,x, y, 3, 6, rot, jk);
    break;
  case 8:  // facing down 1
    GD.sprite(spriteNum,x, y, 4, 4, rot, jk);
    break;
  case 9: // fading down 2
    GD.sprite(spriteNum,x, y, 11, 6, rot, jk);
    break;

    // ALEIN
  case 0:  // right 1
    GD.sprite(spriteNum,x, y, 0, 4, rot, jk);
    break;
  case 1:  // right 2
    GD.sprite(spriteNum,x, y, 0, 6, rot, jk);
    break;
  case 10:  // left 1
    GD.sprite(spriteNum,x, y, 0, 4, 2, jk);
    break;
  case 11: // left 2
    GD.sprite(spriteNum,x, y, 0, 6, 2, jk);
    break;
  case 12:  // up 1
    GD.sprite(spriteNum,x, y, 8, 6, rot, jk);
    break;
  case 13: // up 2
    GD.sprite(spriteNum,x, y, 1, 4, rot, jk);
    break;
  case 14: // down 1 
    GD.sprite(spriteNum,x, y, 8, 4, rot, jk);
    break;
  case 15: // down 2
    GD.sprite(spriteNum,x, y, 7, 6, rot, jk);
    break;



    /* RED PLAYER */
  case 16: //  up 1
    GD.sprite(spriteNum,x, y, 9, 4, rot, jk);
    break;
  case 17: //  up 2
    GD.sprite(spriteNum,x, y, 9, 6, rot, jk);
    break;
  case 18:  //  left 1
    GD.sprite(spriteNum,x, y, 2, 4, 2, jk);    
    break;
  case 19: //  left 2 
    GD.sprite(spriteNum,x, y, 1, 6, 2, jk);    
    break;
  case 20: //  right 1
    GD.sprite(spriteNum,x, y, 2, 4, rot, jk);
    break;
  case 21: // right2
    GD.sprite(spriteNum,x, y, 1, 6, rot, jk);
    break;
  case 22:  //  down 1
    GD.sprite(spriteNum,x, y, 2, 6, rot, jk);
    break;
  case 23: //  down 2
    GD.sprite(spriteNum,x, y, 10, 4, rot, jk);
    break;
  }
}

// put an array of chars on screen
void putascii(int x, int y, const unsigned char *s)
{
  GD.__wstart((y << 6) + x);
  while (*s)
    SPI.transfer((*s++)-1);
  GD.__end();
}

// get a line from ascii at y pos.  from ascii y,  to screen y
void readLine(int destY, int sourceY){
  unsigned char msg[50];
  unsigned char cc=0;
  int x = 0;

  int asciiCount = sourceY*50;

  while (x < 50  ){
    cc = pgm_read_byte_near(&map_mainhall[asciiCount++]);
    msg[x++] = cc;
  }

  putascii( 0,  destY, msg);  // write row to screen
}

void restoreHall()
{
  for (int y=0; y < 39; y++)
    readLine(y,mapPos+y+1);
}

// load common text
void map_load_Text(){
  GD.uncompress(RAM_CHR+(145*16), common_text_chr);
  GD.uncompress(RAM_PAL+(145*8), common_text_pal);
}

// load battlelines
void map_load_Battle(){  
  for (byte y = 0; y < 37; y++)
    GD.copy(RAM_PIC + y * 64, battle_pic + y * 50, 50);
  GD.uncompress(RAM_CHR, battle_chr);
  GD.uncompress(RAM_PAL, battle_pal);

  map_load_Text();    

  mapID=4;  


  GD.uncompress(RAM_SPRIMG, aliens_sprimg);

  GD.copy(PALETTE16A, aliens_sprpal, sizeof(aliens_sprpal));

  // For show, randomly scatter the frames on the screen
  //  GD.__wstartspr(0);
  //  for (int anim = 0; anim < ALIENS_FRAMES; anim++)




  //


  //flip = !flip;  
  //GD.wr(SPR_PAGE, flip);

  GD.__wstartspr(0);
  draw_aliens(184+16, 128+32, 0, 0);
  GD.__end(); 
  //GD.__wstartspr(flip ? 256 : 0);      






}


void hideSprites()
{
  GD.__wstartspr(0);  // start writing sprites at slot 0
  // Now hide all the remaining sprites
  while (GD.spr < 200)
    GD.xhide();
  GD.__end();  

}


void loadHall(signed int roomID){
  mapID= roomID;  

  switch (roomID)
  {
  case -1:       // info desk
    hideSprites();
    mapPos=116-1;
    restoreHall();
    draw_sprite(player_x, player_y, player_anim, 0, 0,0);  // player starting pos 
    break;
  case 0:       // bottom of main hall
    mapPos=79-1;
    restoreHall();
    draw_sprite(player_x, player_y, player_anim, 0, 0,0);  // player starting pos  
    break;
  case 1:      // middle of main hall
    mapPos=42-1;
    restoreHall();
    draw_sprite(player_x, player_y, player_anim, 0, 0,0);  // player starting pos 
    break;
  case 2:     // top of main hall with screen
    mapPos=5-1; 

    draw_sprite(150, 170, ALIEN_DOWN_1, 0, 0,1);   // alien
    draw_sprite(200, 170, ALIEN_DOWN_2, 0, 0,2);   // alien
    draw_sprite(250, 170, ALIEN_DOWN_2, 0, 0,3);   // alien  

    restoreHall();

    draw_sprite(player_x, player_y, player_anim, 0, 0,0);  // player starting pos 

    break;

  case 3:     // outside

    for (byte y = 0; y < 37; y++)
      GD.copy(RAM_PIC + y * 64, map_outside_pic + y * 50, 50);


    draw_sprite(112, 136, SCENER1_RIGHT_1, 0, 0,1);   // alien
    draw_sprite(112, 184, PLAYER_RIGHT_1, 0, 0,2);   // alien
    draw_sprite(120, 216, SCENER1_RIGHT_1, 0, 0,3);   // alien
    draw_sprite(120, 160, SCENER1_RIGHT_1, 0, 0,4);   // alien
    draw_sprite(200, 200, SCENER1_LEFT_1, 0, 0,5);   // alien
    draw_sprite(160, 272, PLAYER_UP_1, 0, 0,6);   // alien
    draw_sprite(176, 248, PLAYER_DOWN_1, 0, 0,7);   // alien

    draw_sprite(player_x, player_y, player_anim, 0, 0,0);  // player starting pos 

    break;

  case 4:     // battle
    clearScreen();
    //      hideSprites();
    map_load_Battle();
    //      map_load_Text();          

    break;
  }


}



void loadSprites(){

  // set background color to gray
  GD.wr16(BG_COLOR, RGB(25, 25, 25));

  // set the first background palette to transparent so we see the gray
  GD.wr16(RAM_PAL, TRANSPARENT);

  GD.copy(PALETTE16A, sprite_player_sprpal, sizeof(sprite_player_sprpal));
  GD.uncompress(RAM_SPRIMG, sprite_player_sprimg);
}


// load outside map
void map_load_Outside(){  

  mapID=3;

  loadSprites();





  GD.uncompress(RAM_CHR, map_outside_chr);
  GD.uncompress(RAM_PAL, map_outside_pal);

  loadHall(mapID);

  map_load_Text();


  player_x = 80;
  player_y=120;

  //  draw_sprite(player_x, player_y, player_anim, 0, 0,0);  // player starting pos 
}

// load main hall  xxx
void map_load_Hall(){

  //mapID=-1;    
  //loadHall(mapID);   

  // clear screen of character data  
  GD.fill(RAM_CHR, 0, 0xFFF); // second number is color 0-3  
  GD.fill(RAM_PIC, 0, 0); // 255 = color index

  GD.uncompress(RAM_CHR, map_mainhall_chr);
  map_load_Text();

  GD.uncompress(RAM_PAL, map_mainhall_pal);

  yscroll=0;

  loadSprites();  
}

// run this after running effects to restore previous map 
void restoreMap(){


  fadeAll();
  clearScreen();

  switch (mapID)
  {
  case -1:
    map_load_Hall();
    loadHall(mapID);
    break;  
  case 0:
    map_load_Hall();
    loadHall(mapID);
    break;  
  case 1:
    mapID=1;
    map_load_Hall();
    loadHall(mapID);


    break;  
  case 2:
    map_load_Hall();
    loadHall(mapID);

    break;  
  case 3:
    map_load_Outside();
    break;  
  case 4:
    map_load_Battle();

    break;  
  }


  map_load_Text();  
}



void scrollup(){
  int eight=0;
  for (int y=0; y < 8; y++)
    if (mapPos>0)
    {
      GD.wr16(SCROLL_Y, yscroll--); 

      GD.waitvblank();

      if (eight==0)
      {
        if (screenLine < 0) 
        {
          screenLine=63;
        }

        // put new line on screen
        readLine(screenLine--,mapPos--); 
        eight=8;
      }
      eight--;
    }
}

void scrolldown(){
  int eight=4;
  for (int y=0; y < 8; y++)   
    if (mapPos+40<119+40) 
    {
      GD.wr16(SCROLL_Y, yscroll++); 
      GD.waitvblank();
      if (eight==8)
      {
        if (screenLine > 63) 
        {
          screenLine=0;
        }
        // put new line on screen
        readLine(screenLine++,40+mapPos++); 
        eight=0;
      }
      eight++;
    }
}



void scrollUpTo(int roomID)
{

  hideSprites();

  screenLine = 63; // line feed the top   

  for (int y=0; y < 37; y++)
    scrollup();

  loadHall(roomID);    
  GD.wr16(SCROLL_Y, 0); 
  yscroll=0;

}

void scrollDownTo(int roomID)
{
  hideSprites();
  screenLine = 39; // line feed the bottom 
  for (int y=0; y < 37; y++)
    scrolldown();
  loadHall(roomID);    
  GD.wr16(SCROLL_Y, 0); 
  yscroll=0;
}

void handleRoomClear(){
  switch (mapID)
  {
  case -1:   
    break;
  case 0:
    break;
  case 1:
    break;
  case 2:
    break;
  }
}

// scroll or not to scroll
void handleRoomChange(){

  switch (mapID)
  {
  case -1:   
    if (player_y < -16)
    {
      scrollUpTo(0); 
      player_y = 280;
    }
    if (player_y > 296)
    {
      fade();
      map_load_Outside();
      // player_y = 0;

    }
    draw_sprite(player_x, player_y, player_anim, 0, 0,0);                  
    break;
  case 0:
    if (player_y < -16) 
    {
      scrollUpTo(1); 
      player_y = 280;      
    }
    if (player_y > 296)
    {
      scrollDownTo(-1); 
      player_y = 0;
    }
    draw_sprite(player_x, player_y, player_anim, 0, 0,0);                  
    break;
  case 1:
    if (player_y < -16) 
    {
      scrollUpTo(2); 
      player_y = 280;
    }
    if (player_y > 296)
    {
      scrollDownTo(0); 
      player_y = 0;
    }
    draw_sprite(player_x, player_y, player_anim, 0, 0,0);                  
    break;
  case 2:
    if (player_y > 296)
    {
      scrollDownTo(1); 
      player_y = 0;
    }
    draw_sprite(player_x, player_y, player_anim, 0, 0,0);                  
    break;

  case 3:   // outside
    if (player_y < 104)  // enter door
    {
      fadeAll();
      player_y = 280;


      mapID=-1;
      loadHall(mapID);

      map_load_Hall();
///xxxx


    }
    if (player_y > 288)
    {
      //scrollDownTo(0); 
      player_y = 288;
    }
    draw_sprite(player_x, player_y, player_anim, 0, 0,0);                  
    break;

  case 4:   // battle


  GD.__wstartspr(0);
  draw_aliens(184+16, 128+32, 0, 0);
  GD.__end(); 


    break;

  }

}


void putchrSound(int x, int y, char s)
{
  if (s>32) {playSample(data,sizeof(data),1);delay(80);}
  s=s-textoffset;
  GD.__wstart((y << 6) + x);
  SPI.transfer(s);
  GD.__end();
  
}

void putchrSound(int x, int y, char *s)
{
  int inc=0;
  while (*s)
  {
    putchrSound(x+inc++,y,*s++);
  }
}


void putchr(int x, int y, int s)
{
  s=s-textoffset;
  GD.__wstart((y << 6) + x);
  SPI.transfer(s);
  GD.__end();
}

void putstr(int x, int y, const char *s)
{
  GD.__wstart((y << 6) + x);
  while (*s)
    SPI.transfer((*s++)-textoffset);
  GD.__end();
}

void textRect(byte x, byte y, byte width, byte height,  const char *s)
{
  putchr(x, y, ACS_ULCORNER+16); // top left
  for (byte i = 1; i < width; i++)    //top middle
    putchr(x+i, y, ACS_HLINETOP+16);    
  putchr(x+width, y, ACS_URCORNER+16);  //top right

  for (byte i = 1; i < height-1; i++)     
  {
    putchr(x, y+i, ACS_VLINERIGHT+16);    //left side

    for (byte j = 1; j < width; j++)    //filler
    {
      //        putchr(x+j, y+i, (*s++)-17);    
      putchr(x+j, y+i, 16+16);    
    }
    putchr(x+width, y+i, ACS_VLINE+16);    //right side
  }

  putchr(x, y+height-1, ACS_LLCORNER+16); // bottom left
  for (byte i = 1; i < width; i++)    //bottom middle
    putchr(x+i, y+height-1, ACS_HLINE+16);    
  putchr(x+width, y+height-1, ACS_LRCORNER+16);  //bottom right

  // animate the text wrap to width
  // check for keypress to skip
  int count = 0;
  int textLength = sizeof(char) * strlen(s);
  for (byte i = 1; i < height; i++)     
  {
    for (byte j = 1; j < width; j++)    //filler
    {
      if (count == textLength) break;
      putchrSound(x+j, y+i, (*s++));
//      delay(80);
      count++;        
    }
  }
}





void movePlayer(unsigned char c, unsigned char stepCount){
  for(int numsteps=0; numsteps<stepCount; numsteps++)
  {
    // change to attack animation and display the sword sprite
    switch (c)
    {
    case PS2_UPARROW:
      player_dir = UP;
      player_y -= SPEED;
      player_foot_count++;
      break;
    case PS2_DOWNARROW:
      player_dir = DOWN;
      player_y += SPEED;
      player_foot_count++;
      break;
    case PS2_LEFTARROW:
      player_dir = LEFT;
      player_x -= SPEED;
      player_foot_count++;
      break;
    case PS2_RIGHTARROW:
      player_dir = RIGHT;
      player_x += SPEED;
      player_foot_count++;
      break;

    default:
      player_dir = 4; //dont move

      break;
    }

    //smooth animate between speed steps
    for(int i=0; i<SPEED; i++) 
    {
      // is it time to switch walking animation?
      if (player_foot_count > FOOT_COUNT_MAX)
      {
        player_foot ^= 1;
        player_foot_count = 0;
      } 

      GD.waitvblank(); 

/*
      char msg[30];
      sprintf(msg, "player x: %3d ", player_x);
      putstr(0,0,msg);
      sprintf(msg, "player y: %3d ", player_y);
      putstr(0,1,msg);

      sprintf(msg, "player anim: %3d ", player_anim);
      putstr(0,2,msg);

      sprintf(msg, "map : %3d ", mapID);
      putstr(0,3,msg);
*/


      // hide the players
      //        for(int j=0; j<16; j++)
      //          draw_sprite(400, 0, j, 0, 0);    

      switch(player_dir)
      {
      case UP:
        player_anim = player_foot ? PLAYER_UP_1 : PLAYER_UP_2;
        draw_sprite(player_x, player_y-i+SPEED, player_anim, 0, 0,0);        
        break;
      case DOWN:
        player_anim = player_foot ? PLAYER_DOWN_1 : PLAYER_DOWN_2;
        draw_sprite(player_x, player_y+i-SPEED, player_anim, 0, 0,0);        
        break;
      case LEFT:
        player_anim = player_foot ? PLAYER_LEFT_1 : PLAYER_LEFT_2;
        draw_sprite(player_x-i+SPEED, player_y, player_anim, 0, 0,0);
        break;
      case RIGHT:
        player_anim = player_foot ? PLAYER_RIGHT_1 : PLAYER_RIGHT_2;
        draw_sprite(player_x+i-SPEED, player_y, player_anim, 0, 0,0);        
        break;
      default:
        //player_anim = player_foot ? PLAYER_RIGHT_1 : PLAYER_RIGHT_2;      
        if (mapID != 4)
        draw_sprite(player_x, player_y, player_anim, 0, 0,0);                
      }
    }  
  }
  handleRoomChange();
}





void moveOtherPlayer(unsigned char c, unsigned char stepCount){
  for(int numsteps=0; numsteps<stepCount; numsteps++)
  {
    // change to attack animation and display the sword sprite
    switch (c)
    {
    case PS2_UPARROW:
      player_dir = UP;
      player_y -= SPEED;
      player_foot_count++;
      break;
    case PS2_DOWNARROW:
      player_dir = DOWN;
      player_y += SPEED;
      player_foot_count++;
      break;
    case PS2_LEFTARROW:
      player_dir = LEFT;
      player_x -= SPEED;
      player_foot_count++;
      break;
    case PS2_RIGHTARROW:
      player_dir = RIGHT;
      player_x += SPEED;
      player_foot_count++;
      break;

    default:
      player_dir = 4; //dont move

      break;
    }

    //smooth animate between speed steps
    for(int i=0; i<SPEED; i++) 
    {
      // is it time to switch walking animation?
      if (player_foot_count > FOOT_COUNT_MAX)
      {
        player_foot ^= 1;
        player_foot_count = 0;
      } 

      GD.waitvblank(); 

/*
      char msg[30];
      sprintf(msg, "player x: %3d ", player_x);
      putstr(0,0,msg);
      sprintf(msg, "player y: %3d ", player_y);
      putstr(0,1,msg);

      sprintf(msg, "player anim: %3d ", player_anim);
      putstr(0,2,msg);

      sprintf(msg, "map : %3d ", mapID);
      putstr(0,3,msg);
*/

      // hide the players
      //        for(int j=0; j<16; j++)
      //          draw_sprite(400, 0, j, 0, 0);    

      switch(player_dir)
      {
      case UP:
        player_anim = player_foot ? SCENER1_UP_1 : SCENER1_UP_2;
        draw_sprite(player_x, player_y-i+SPEED, player_anim, 0, 0,5);        
        break;
      case DOWN:
        player_anim = player_foot ? SCENER1_DOWN_1 : SCENER1_DOWN_2;
        draw_sprite(player_x, player_y+i-SPEED, player_anim, 0, 0,5);        
        break;
      case LEFT:
        player_anim = player_foot ? SCENER1_LEFT_1 : SCENER1_LEFT_2;
        draw_sprite(player_x-i+SPEED, player_y, player_anim, 0, 0,5);
        break;
      case RIGHT:
        player_anim = player_foot ? SCENER1_RIGHT_1 : SCENER1_RIGHT_2;
        draw_sprite(player_x+i-SPEED, player_y, player_anim, 0, 0,5);        
        break;
      default:
        //player_anim = player_foot ? PLAYER_RIGHT_1 : PLAYER_RIGHT_2;      
        if (mapID != 4)
        draw_sprite(player_x, player_y, player_anim, 0, 0,5);                
      }
    }  
  }
}


void ending(){
 
  map_load_Hall();
  loadHall(2); // load main screen
 
  textRect(15,2,18,13,  "The battle of    effects is       undecided.  It   has to be        continued at     @Party 2013..."); 

  textRect(15-2-2-2,30-3,31,5,  " ");   
  putstr(15-2-2,31-3,"http:\/\/atparty-demoscene.net");
 putstr(15-2-2,32-2,"June 14, 2013");


player_x=200;
player_y=192;

draw_sprite(200, 192, PLAYER_DOWN_1, 0, 0,0);   


player_x=96;
player_y=88;
draw_sprite(96, 88, SCENER1_DOWN_1, 0, 0,5);   


moveOtherPlayer(PS2_LEFTARROW,6);
moveOtherPlayer(PS2_DOWNARROW,13);
moveOtherPlayer(PS2_RIGHTARROW,17);
  
  
  delay(26000);
  /*
    while (1) 
  {
  }
  */
  
         runAscii((256*8) + 3*(8*38) ); // ascii is 256 lines long x 8 pixel tiles
      //runAscii((256*8));

  delay(20000);
  
}





int runmenu(char x, char y, const char *menu[], int defaultitem, boolean scanKey)
{
  int key, i,j, itemno;
  int nitems, width;
  char *s;

  itemno = defaultitem-1;
  width = 20;

  width = 10;
  nitems = 0;
  while (menu[nitems] != 0) {
    for (j=0;menu[nitems][j];j++);
    if (j>width)
      width = j;
    nitems++;
  }
  width+=2;

  if (itemno < 0 || itemno > nitems)
    itemno = 0;

  putchr(x-1,y,ACS_ULCORNER+16);
  for (i=0;i<width+2;i++) 
    putchr(x+i,y,ACS_HLINETOP+16);
  putchr(x+width+2,y,ACS_URCORNER+16);


  for (i = 0;i<nitems;i++) {
    //gotoxy(x,y+i+1);
    putchr(x+width+2,y+i+1,ACS_VLINE+16);
    //      putchr(x,y+i+1,' ');
    //      if (i == itemno)
    //        textattr(YELLOW);
    s = 0;
    for (j=0;j<width;j++) {
      if (s && *s)
        putchr(x+j+2,y+i+1,*s++);
      else putchr(x+j+2,y+i+1,' ');
      if (s == 0)
        s = (char *)menu[i];
    }
    //       textattr(CYAN<<4 | BLACK);

    if (i == itemno)
    {
      putchr(x,y+i+1,ACS_LMENUON+16);
      putchr(x+1,y+i+1,ACS_RMENUON+16);
    }
    else
    {
      putchr(x,y+i+1,ACS_LMENUOFF+16);
      putchr(x+1,y+i+1,ACS_RMENUOFF+16);          
    }    
    putchr(x-1,y+i+1,ACS_VLINERIGHT+16);
  }

  //  gotoxy(x,y+nitems+1);
  putchr(x-1,y+nitems+1,ACS_LLCORNER+16);
  for (i=0;i<width+2;i++) 
    putchr(x+i,y+nitems+1,ACS_HLINE+16);
  putchr(x+width+2,y+nitems+1,ACS_LRCORNER+16);

  if (scanKey)
    playSample(data,sizeof(data),1);


  if (scanKey)
    while (1) 
    {
      if (keyboard.available()) {
        // read the next key
        char key2 = keyboard.read();

        switch(key2) {
        case PS2_UPARROW: 
          if (itemno>0) itemno--;  
          else itemno = nitems-1;       
          playSample(data,sizeof(data),1);   
          runmenu(x,y, menu, itemno+1,false);  
          break;
        case PS2_DOWNARROW: 
          itemno++; 
          itemno %= nitems; 
          playSample(data,sizeof(data),1);    
          runmenu(x,y, menu, itemno+1,false);
          break;
        case PS2_ESC:
          if (mapID == 4)
          {
            map_load_Battle();  

          }
          else
          {
            loadHall(mapID);           
          }
          return 0;
        case PS2_ENTER: 
          playSample(data,sizeof(data),1); 
          return itemno+1;
          break;
        }
      }
    }
}

// effects menu
void menu1()                     
{
  int item;
  item = 0;
  do {
    item = runmenu(9,5, submenu1, item,true);
    switch (item)
    {
    case 0:
      break;
    case 1:
      fadeAll();
      hideSprites();
      runSubpixel(400);
      restoreMap();  
      break;
    case 2:
      fadeAll();
      hideSprites();
      runFire(200*5); // 12 secs    
      restoreMap();  
      break;

    case 3:
      fadeAll();
      hideSprites();
      runTwister(200);
      restoreMap();  
      break;

    case 4:
      fadeAll();
      hideSprites();
      runCopper(400);
      restoreMap();  
      break;

    case 5:
      fadeAll();
      hideSprites();
      runJulia(200);   
      restoreMap();  
      break;


    case 6:
      fadeAll();
      //hideSprites();
      runBigVector(300,vector_largebox_dots);
      restoreMap();  
      break;

    case 7:
      fadeAll();
      //hideSprites();
      runSmallVector(200,vector_dna_dots,vector_dna_color);
      restoreMap();  
      break;

    case 8:
      fadeAll();
      hideSprites();
      runSmallVector(200,vector_chicken_dots,vector_chicken_color);
      // chicken here
      //runDeform(4,200);    
      restoreMap();  
      break;


    case 9:
      fadeAll();
      hideSprites();
      runRotozoomer(400);
      restoreMap();  
      break;

    case 10:
      fadeAll();
      hideSprites();
      metaball2();   
      fadeAll();
      ending();

      hideSprites();
      runAscii((256*8) + 3*(8*38) ); // ascii is 256 lines long x 8 pixel tiles      
      break;

    case 11:
      hideSprites();
      //  runAscii((256*8) + 3*(8*38) ); // ascii is 256 lines long x 8 pixel tiles
      //runAscii((256*8));
      restoreMap();  
      break;

    default :
      break;
    }
  } 
  while (item >0);
}

void menu3()                     
{
  int item;
  item = 0;
  do {

    item = runmenu(7,9, submenu3, item,true);

    switch (item) {
    default:
      break;
    }
  } 
  while (item > 0);
}


// read a one-liner
void saySomething(){
  if (sayCounter > sizeof(&sayText))
    sayCounter=0;
  char msg[32]; 
  char cc;
  int x=0;
  while (x < 32  ){
    cc = pgm_read_byte_near(&sayText[sayCounter][x]);
    msg[x++] = cc;
  }

  textRect(14,3,32,3,  msg);
  sayCounter++;

  delay(500);
  loadHall(mapID);
}



