/*
 * hardmod.c
 *
 * Created: 8/11/2011 4:08:44 PM
 *  Author: Eric
 */

//https://github.com/stg/SyltJamSynth2011/blob/master/arduino-experiments/modplayer/addressed_memory.c
//http://nicotak.com/avr/ledgame.html#dl
//https://bitbucket.org/ddimitrov38/modplay/src/91b8de13e657b4ae1f4d74ee6b346d8b3c1cb6af/hardmod?at=master




#include "modformat.h"



#include <SPI.h>
#include <GD.h>
#include <digitalWriteFast.h>
#include <TimerOne.h>

#define RENDERWIDTH 50
#define RENDERHEIGHT 37


#include "modplayer.h"

byte fire_buffer[(50*37)+51];
/* common audio */
#include "soundbuffer.h"
#define SOUNDBUFFERHI 0x3f00
#define SOUNDBUFFERLO 0x4000
#define SOUNDBUFFER 0x3f00
byte writepointer = 0;

void fillSampleBuffer(){
  byte readpointer = GD.rd(COMM+0);
  byte fullness = writepointer - readpointer;

  while (fullness < 254  ) {
    fillSample();
    GD.wr(SOUNDBUFFER  + writepointer, mastersample);                 
    writepointer++;
    fullness++;
  } 
}


void setup(){
    GD.begin();
    GD.fill(RAM_PIC, 0, 0x0FFF); // 255 = color index
    GD.fill(RAM_CHR, 0, 0x0FFF); // second number is color 0-3  

    GD.microcode(soundbuffer_code, sizeof(soundbuffer_code));
//    modload(songdata_fears);
    modload(subi_songdata);
  Timer1.initialize(20000);         // for subi song  
  Timer1.attachInterrupt(fillSampleBuffer);  // attaches callback() as a timer overflow interrupt
    
    
//  modplay();
}

void loop() {
  fire();
}

class Sinescroller
{
public:
  Sinescroller();
  void sineScroller();

private:
  void initFont();
  void initScrollText();
  void initSine();

private:

  unsigned int scrollPos;
  unsigned int scrollOffset;
  unsigned int sinePos;
  unsigned short font[46 * 16];
  char fontLookup[256];
#define sinelength 512 
  int ssine[sinelength];
  //  int rasters[240];
};






void fire(){
  // generate flame color palette in RGB. need 256 bytes available memory
  for(byte i=0; i<86; i++)
  {
    GD.setpal(i*4, RGB(i*3,0,0));          // Black to red
    GD.setpal((i+85)*4, RGB(255,i*3,0));   // Red to yellow
    GD.setpal((i+170)*4, RGB(255,255,i*3));   // yellow to white
  } 

  //    showPalette();
  //    delay(5000);
  int timeDisplacement=3950;  // number of frames to run
  int  fire_length = RENDERWIDTH*RENDERHEIGHT;
  byte widthLeft = RENDERWIDTH-1;
  byte widthRight = RENDERWIDTH+1;
  int bufferY = (RENDERHEIGHT*64)+RAM_PIC;
  byte pixel_buffer[RENDERWIDTH*2];

  //perlin Noise = new perlin();

  Sinescroller sc;

  do{    


    for(byte x = 0; x < RENDERWIDTH; x++){
      for(byte y = 0; y < RENDERHEIGHT; y++){      
        //      fire_buffer[x+y*RENDERWIDTH] = 0;
      }
    }


    //    for(byte x = 0; x < RENDERWIDTH; x++){
    //      fire_buffer[x+fire_length] = sampleleft;
    //      fire_buffer[x+fire_length] = random(255);
    //    }

    sc.sineScroller();
    screen4();




    // Do the fire calculations for every pixel, from top to bottom
    unsigned int currentPixelIndex = 1; // start from center
    for (int y = RAM_PIC; y < bufferY;y+=64) { 
      for(byte x = 0; x < RENDERWIDTH; ) {
        // Add pixel values around current pixel
        // Output everything to screen using our palette colors      
        fire_buffer[currentPixelIndex] = ((fire_buffer[currentPixelIndex]
          + fire_buffer[currentPixelIndex+widthLeft]
          //          + fire_buffer[currentPixelIndex+RENDERWIDTH]
        + fire_buffer[currentPixelIndex +widthRight]
          )  >>2) ;          

                    if (currentPixelIndex == RENDERWIDTH*RENDERHEIGHT) fire_buffer[currentPixelIndex] = 0;                  

       // pixel_buffer[x++] =  fire_buffer[currentPixelIndex++];
       x++;
       currentPixelIndex++;

      }
      //GD.copy2(y,pixel_buffer,RENDERWIDTH);
    }
    fb();
  }
  while(--timeDisplacement);
}


float _sin(float x)
{
  //always wrap input angle to -PI..PI
  if (x < -3.14159265)
    x += 6.28318531;
  else
    if (x >  3.14159265)
      x -= 6.28318531;

  //compute sine
  if (x < 0)
    return 1.27323954 * x + .405284735 * x * x;
  else
    return 1.27323954 * x - 0.405284735 * x * x;

}


// Cube vertex geometry
#define CubeVertexLength 8
static char CubeVertex[8][3] =
{
  {
    -1, -1, 1  }
  ,
  {
    -1, 1, 1  }
  ,
  {
    1, 1, 1  }
  ,
  {
    1, -1, 1  }
  ,
  {
    -1, -1, -1  }
  ,
  {
    -1, 1, -1  }
  ,
  {
    1, 1, -1  }
  ,
  {
    1, -1, -1  }
  ,
};


// Define the screen width and height in terms of characters
#define CHAR_WIDTH 50
#define CHAR_HEIGHT 37

static char hex[] = "0123456789ABCDEF";



// Cube edge cata
#define CubeEdgesLength 12
static char CubeEdges[12][2] =
{
  {
    0, 1  }
  ,
  {
    1, 2  }
  ,
  {
    2, 3  }
  ,
  {
    3, 0  }
  ,
  {
    4, 5  }
  ,
  {
    5, 6  }
  ,
  {
    6, 7  }
  ,
  {
    7, 4  }
  ,
  {
    0, 4  }
  ,
  {
    1, 5  }
  ,
  {
    2, 6  }
  ,
  {
    3, 7  }
  ,
};


void screen4()
{
  // Total time
  //  static float TotalTime = 0.0f;
  //    TotalTime += dT;

  /*** Internal Data declaration ***/
  static float CameraRotX = 0.0f;
  static float CameraRotY = 0.0f;
  static float CameraRotZ = 0.0f;

  /*** Prepare Data ***/

  // Slightly grow the rotations
  CameraRotX += .03;
  CameraRotY += .03;
  CameraRotZ = .01;

  /*** Render Scene ***/

  // Find the center of the image
  int CenterX = CHAR_WIDTH / 2;
  int CenterY = (CHAR_HEIGHT / 2);

  // Create an on-screen point list we will be working with
  int PointList[CubeVertexLength][2];

  // For each vertex point
  for(int i = 0; i < CubeVertexLength; i++)
  {
    // The resulting vertex point we are working on
    // Note that we are creating a new object, not making a copy-reference
    float WorkingVertexX = CubeVertex[i][0];
    float WorkingVertexY = CubeVertex[i][1];
    float WorkingVertexZ = CubeVertex[i][2];

    // Apply rotation onto the vertex
    float Temp = WorkingVertexZ;
    WorkingVertexZ = -WorkingVertexX * sin(CameraRotY) - WorkingVertexZ * cos(CameraRotY);
    WorkingVertexX = -WorkingVertexX * cos(CameraRotY) + Temp * sin(CameraRotY);

    Temp = WorkingVertexZ;
    WorkingVertexZ = -WorkingVertexY * sin(CameraRotX) + WorkingVertexZ * cos(CameraRotX);
    WorkingVertexY = WorkingVertexY * cos(CameraRotX) + Temp * sin(CameraRotX);

    Temp = WorkingVertexX;
    WorkingVertexX = WorkingVertexX * cos(CameraRotZ) - WorkingVertexY * sin(CameraRotZ);
    WorkingVertexY = WorkingVertexY * cos(CameraRotZ) + Temp * sin(CameraRotZ);

    // Apply camera translation after the rotation, so we are actually just rotating the object
    /*
        WorkingVertexX -= CameraPosX;
     WorkingVertexY -= CameraPosY;
     */

    /*
        if(TotalTime <= 5)
     {
     
     float Distance = 30 - TotalTime * TotalTime * 0.2f;
     if(Distance < 2)
     Distance = 2;
     WorkingVertexZ += Distance;
     }
     else
     {
     static float NextTotalTime = 0;
     NextTotalTime += dT;
     
     // Pull distance back...
     float Distance = 2 + NextTotalTime * NextTotalTime * 0.5f;
     if(Distance > 3)
     Distance = 3;
     WorkingVertexZ += Distance;
     }
     */

    //            static float NextTotalTime = 0;
    //            NextTotalTime += dT;

    // Pull distance back...
    float Distance = 3.2;//2 + NextTotalTime * NextTotalTime * 0.5f;

    //            if(Distance > 3.5)
    //                Distance = 3.5;
    WorkingVertexZ += Distance;


    // Convert from x,y,z to x,y
    // This is called a projection transform
    // We are projecting from 3D back to 2D
    static float RatioConst = 25;
    int ScreenX = (RatioConst * (WorkingVertexX)) / WorkingVertexZ;
    int ScreenY = (RatioConst * (WorkingVertexY)) / WorkingVertexZ;

    // Save this on-screen position to render the line locations
    PointList[i][0] = int(CenterX + ScreenX);
    PointList[i][1] = int(CenterY + ScreenY);
  }


  for(int i = 0; i < CubeEdgesLength; i++)
  {
    // Find the two points we are working on
    int Point1X = PointList[CubeEdges[i][0]][0];
    int Point1Y = PointList[CubeEdges[i][0]][1];

    int Point2X = PointList[CubeEdges[i][1]][0];
    int Point2Y = PointList[CubeEdges[i][1]][1];

    // Render the edge by looking up our vertex list
    //            RenderLine(Point1X, Point1Y, Point2X, Point2Y, color(0,255,0));
    RenderLine(Point1X, Point1Y, Point2X, Point2Y, 230);            
  }
}

void DrawChar(byte x, byte y, byte newChar)
{
  /*
    char msg[2];
   msg[0] = newChar;
   msg[1] = 0;
   GD.putstr(x, y, msg);
   */

  //    pD[x+y*RENDERWIDTH]=newChar;


  fire_buffer[x+y*50]=newChar;    

}



void RenderLine(int x0, int y0, int x1, int y1, char lineChar)
{
  int dx = abs(x1-x0);
  int dy = abs(y1-y0);

  int sx, sy;

  if(x0 < x1)
    sx = 1;
  else
    sx = -1;
  if(y0 < y1)
    sy = 1;
  else
    sy = -1;

  int err = dx - dy;

  while(true)
  {
    DrawChar(x0, y0, lineChar);
    if(x0 == x1 && y0 == y1)
      break;
    int e2 = 2 * err;
    if(e2 > -dy)
    {
      err = err - dy;
      x0 = x0 + sx;
    }
    if(e2 < dx)
    {
      err = err + dx;
      y0 = y0 + sy;
    }
  }
}










